<?php

include_once(dirname(__FILE__).'/Base.php');

class TypeDate extends TypeBase
{
  var $DatabaseCompareOperators = array('Rovno' => '=', 'Nerovno' => '!=', 'Menší' => '<', 'Větší' => '>');

  function OnView($Item)
  {
    global $MonthNames;

    if($Item['Value'] == 0) return('');
    if((strtolower($Item['Value']) == 'now') or (strtolower($Item['Value']) == '')) $Item['Value'] = time();
    $Parts = getdate($Item['Value']);

    $Output = $Parts['mday'].'. '.$MonthNames[$Parts['mon']].' '.$Parts['year'];
    return($Output);
  }

  function OnEdit($Item)
  {
    global $MonthNames;
   
    if((strtolower($Item['Value']) == 'now') or (strtolower($Item['Value']) == '')) $Item['Value'] = time();
    $Parts = getdate($Item['Value']);

    $Output = '';
    //if($Item['Value'] == '') $Checked = ' checked="1"'; else $Checked = '';
    //$Output .= '<input type="checkbox" name="'.$Item['Name'].'-null"'.$Checked.'/>';

    // Day
    $Output .= '<select name="'.$Item['Name'].'-day">';
    for($I = 1; $I <= 31; $I++)
    {
      if($Parts['mday'] == $I) $Selected = ' selected="1"'; else $Selected = '';
      $Output .= '<option value="'.$I.'"'.$Selected.'>'.$I.'</option>';
    }
    $Output .= '</select>';
    // Month
   $Output .= '<select name="'.$Item['Name'].'-month">';
   for($I = 1; $I <= 12; $I++)
    {
      if($Parts['mon'] == $I) $Selected = ' selected="1"'; else $Selected = '';
      $Output .= '<option value="'.$I.'"'.$Selected.'>'.$MonthNames[$I].'</option>';
    }
    $Output .= '</select>';
    // Year
    $Output .= '<select name="'.$Item['Name'].'-year">';
    for($I = 1900; $I < 2100; $I++)
    {
      if($Parts['year'] == $I) $Selected = ' selected="1"'; else $Selected = '';
      $Output .= '<option value="'.$I.'"'.$Selected.'>'.$I.'</option>';
    }
    $Output .= '</select>';
    return($Output);
  }

  function OnLoad($Item)
  {
    return(mktime(0, 0, 0, $_POST[$Item['Name'].'-month'], $_POST[$Item['Name'].'-day'], $_POST[$Item['Name'].'-year']));
  }
  
  function OnLoadDb($Item)
  {
    return(MysqlDateToTime($Item['Value']));
  }

  function OnSaveDb($Item)
  {
    return(date('Y-m-d', $Item['Value']));
  }

  function DatabaseEscape($Value)
  {
    return('"'.addslashes($Value).'"');
  }
}
