<?php

include_once(dirname(__FILE__).'/Base.php');

class TypeDateTime extends TypeBase
{
  var $DatabaseCompareOperators = array('Rovno' => '=', 'Nerovno' => '!=', 'Menší' => '<', 'Větší' => '>');

  function OnView($Item)
  {
    global $MonthNames;
    
    if($Item['Value'] == 0) return('');
    if((strtolower($Item['Value']) == 'now') or (strtolower($Item['Value']) == '')) $Item['Value'] = time();
    $Parts = getdate($Item['Value']);
    $Output = $Parts['mday'].'.'.$Parts['mon'].'.'.$Parts['year'].' '.
      $Parts['hours'].':'.$Parts['minutes'].':'.$Parts['seconds'];
    return($Output);
  }

  function OnEdit($Item)
  {
    global $MonthNames;

    if((strtolower($Item['Value']) == 'now') or (strtolower($Item['Value']) == '')) $Item['Value'] = time();
    $Parts = getdate($Item['Value']);

    // Hour
    $Output = '<select name="'.$Item['Name'].'-hour">';
    for($I = 1; $I <= 24; $I++)
    {
      if($Parts['hours'] == $I) $Selected = ' selected="1"'; else $Selected = '';
      $Output .= '<option value="'.$I.'"'.$Selected.'>'.$I.'</option>';
    }
    $Output .= '</select>';
    // Minute
    $Output .= '<select name="'.$Item['Name'].'-minute">';
    for($I = 1; $I <= 60; $I++)
    {
      if($Parts['minutes'] == $I) $Selected = ' selected="1"'; else $Selected = '';
      $Output .= '<option value="'.$I.'"'.$Selected.'>'.$I.'</option>';
    }
    $Output .= '</select>';
    // Second
    $Output .= '<select name="'.$Item['Name'].'-second">';
    for($I = 1; $I <= 60; $I++)
    {
      if($Parts['seconds'] == $I) $Selected = ' selected="1"'; else $Selected = '';
      $Output .= '<option value="'.$I.'"'.$Selected.'>'.$I.'</option>';
    }
    $Output .= '</select>';
    // Day
    $Output .= ' <select name="'.$Item['Name'].'-day">';
    for($I = 1; $I <= 31; $I++)
    {
      if($Parts['mday'] == $I) $Selected = ' selected="1"'; else $Selected = '';
      $Output .= '<option value="'.$I.'"'.$Selected.'>'.$I.'</option>';
    }
    $Output .= '</select>';
    // Month
    $Output .= '<select name="'.$Item['Name'].'-month">';
    for($I = 1; $I <= 12; $I++)
    {
      if($Parts['mon'] == $I) $Selected = ' selected="1"'; else $Selected = '';
      $Output .= '<option value="'.$I.'"'.$Selected.'>'.$MonthNames[$I].'</option>';
    }
    $Output .= '</select>';
    // Year
    $Output .= '<select name="'.$Item['Name'].'-year">';
    for($I = 1900; $I < 2100; $I++)
    {
      if($Parts['year'] == $I) $Selected = ' selected="1"'; else $Selected = '';
      $Output .= '<option value="'.$I.'"'.$Selected.'>'.$I.'</option>';
    }
    $Output .= '</select>';
    return($Output);
  }

  function OnLoad($Item)
  {
    return(mktime($_POST[$Item['Name'].'-hour'], $_POST[$Item['Name'].'-minute'], $_POST[$Item['Name'].'-second'],
      $_POST[$Item['Name'].'-month'], $_POST[$Item['Name'].'-day'], $_POST[$Item['Name'].'-year']));
  }

  function OnLoadDb($Item)
  {
    return(MysqlDateTimeToTime($Item['Value']));
  }
  
  function OnSaveDb($Item)
  {
    return(date('Y-m-d H:i:s', $Item['Value']));
  }

  function DatabaseEscape($Value)
  {
    return('"'.addslashes($Value).'"');
  }
}
