<?php

include_once(dirname(__FILE__).'/Base.php');

class TypeTime extends TypeBase
{
  var $DatabaseCompareOperators = array('Rovno' => '=', 'Nerovno' => '!=', 'Menší' => '<', 'Větší' => '>');

  function OnView($Item)
  {
    if($Item['Value'] == 0) return('');
    if((strtolower($Item['Value']) == 'now') or (strtolower($Item['Value']) == '')) $Item['Value'] = time();
    $TimeParts = getdate($Item['Value']);

    $Output = $TimeParts['hours'].':'.$TimeParts['minutes'].':'.$TimeParts['seconds'];
    return($Output);
  }

  function OnEdit($Item)
  {
    if((strtolower($Item['Value']) == 'now') or (strtolower($Item['Value']) == '')) $Item['Value'] = time();
    $TimeParts = getdate($Item['Value']);

    // Hour
    $Output = '<select name="'.$Item['Name'].'-hour">';
    for($I = 1; $I <= 24; $I++)
    {
      if($TimeParts['hours'] == $I) $Selected = ' selected="1"'; else $Selected = '';
      $Output .= '<option value="'.$I.'"'.$Selected.'>'.$I.'</option>';
    }
    $Output .= '</select>';
    // Minute
    $Output .= '<select name="'.$Item['Name'].'-minute">';
    for($I = 1; $I <= 60; $I++)
    {
      if($TimeParts['month'] == $I) $Selected = ' selected="1"'; else $Selected = '';
      $Output .= '<option value="'.$I.'"'.$Selected.'>'.$I.'</option>';
    }
    $Output .= '</select>';
    // Second
    $Output .= '<select name="'.$Item['Name'].'-second">';
    for($I = 1; $I <= 60; $I++)
    {
      if($TimeParts['seconds'] == $I) $Selected = ' selected="1"'; else $Selected = '';
      $Output .= '<option value="'.$I.'"'.$Selected.'>'.$I.'</option>';
    }
    $Output .= '</select>';
    return($Output);
  }

  function OnLoad($Item)
  {
    return(mktime($_POST[$Item['Name'].'-hour'], $_POST[$Item['Name'].'-minute'], $_POST[$Item['Name'].'-second']));
  }

  function OnLoadDb($Item)
  {
    return(MysqlTimeToTime($Item['Value']));
  }

  function OnSaveDb($Item)
  {
    return(date('H:i:s', $Item['Value']));
  }

  function DatabaseEscape($Value)
  {
    return('"'.addslashes($Value).'"');
  }
}
