<?php

define('PAGE_NOT_FOUND', 'Stránka nenalezena');

class Page extends Module
{
  var $TimeStart;
  var $FormatHTML = false;
  var $ShowRuntimeInfo = false;
  var $ClearPage = false;
  var $BasicHTML = false;
  var $ParentClass = '';
  var $ShortTitle;
  var $FullTitle;
  
  function __construct($System)
  {
    parent::__construct($System);
    
    $this->FormatHTML = $this->System->Config['Web']['FormatHTML'];
    $this->ShowRuntimeInfo = $this->System->Config['Web']['ShowRuntimeInfo'];
  }

  function SystemMessage($Title, $Text)
  { 
    return('<table align="center"><tr><td><div class="SystemMessage"><h3>'.$Title.'</h3><div>'.$Text.'</div></div></td></tr></table>');
    //ShowFooter();
    //die();
  }

  function ShowHeader($Title, $Path)
  {
    $ScriptName = $_SERVER['REQUEST_URI'];
    while(strpos($ScriptName, '//') !== false)
      $ScriptName = str_replace('//', '/', $ScriptName);
    if(strpos($ScriptName, '?') !== false)
      $ScriptName = substr($ScriptName, 0, strrpos($ScriptName, '?'));
    $ScriptName = substr($ScriptName, strlen($this->System->Link('')));
    if(substr($ScriptName, -1, 1) == '/') $ScriptName = substr($ScriptName, 0, -1);
    $Page = $this;
    $Navigation = '';
    while($Page)
    { 
      $Navigation = ' &gt; <a href="'.$this->System->Link($ScriptName).'/">'.$Page->ShortTitle.'</a>'.$Navigation;
      
      if($Page->ParentClass != '')
      {
        $PageClass = $Page->ParentClass;
        $Page = new $PageClass($this->System);
        $ScriptName = substr($ScriptName, 0, strrpos($ScriptName, '/'));
      } else $Page = null;
    } 
    $Navigation = substr($Navigation, 6);

    $BodyParam = '';
    if(isset($this->Load)) $BodyParam .= ' onload="'.$this->Load.'"';
    if(isset($this->Unload)) $BodyParam .= ' onunload="'.$this->Unload.'"';
    $Output = '<?xml version="1.0" encoding="'.$this->System->Config['Web']['Charset'].'"?>'."\n".
    '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">'.
    '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="cs" lang="cs">'.
    '<head><link rel="stylesheet" href="'.$this->System->Link('/style/').$this->System->Config['Web']['Style'].'/style.css" type="text/css" media="all" />'.
    '<meta http-equiv="content-type" content="application/xhtml+xml; charset='.$this->System->Config['Web']['Charset'].'" />'.
    '<script type="text/javascript" src="'.$this->System->Link('/style/').$this->System->Config['Web']['Style'].'/global.js"></script>'.
    '<title>'.$this->System->Config['Web']['Title'].' - '.$Path.'</title>
    </head><body'.$BodyParam.'>';
    if($this->BasicHTML == false)
    {
      $Output .= '<div id="Title">'.$Title.'</div>
      <div class="Navigation"><span class="MenuItem"><strong>Navigace :: </strong> '.$Navigation.'</span><div class="MenuItem2">';
      if($this->System->Config['Web']['UserSupport'] == 1)
      {
        if($this->System->User->User['Id'] == null)
          $Output .= '<a href="'.$this->System->Link('/?Action=LoginForm').'">Přihlášení</a> <a href="'.$this->System->Link('/?Action=UserRegister').'">Registrace</a>'; 
          else $Output .= $this->System->User->User['Name'].' <a href="'.$this->System->Link('/?Action=Logout').'">Odhlásit</a>';
     } else $Output .= '&nbsp;';
//   <a href="'.$this->System->Link('/?Action=UserOptions').'">Nastavení</a>'; 
      $Output .= '</div></div>';
    }
    return($Output);
  }

  function ShowFooter()
  {
    global $ScriptTimeStart;
    $Time = round(GetMicrotime() - $ScriptTimeStart, 2);
    $Output = '';
    if($this->BasicHTML == false)
    {
      $Output .= '<div id="Footer">
     <i>| Správa webu: '.$this->System->Config['Web']['Admin'].' | e-mail: '.$this->System->Config['Web']['AdminEmail'].' |';
      if($this->ShowRuntimeInfo == true) $Output .= ' Doba generování: '.$Time.' s / '.ini_get('max_execution_time').
        ' s | Použitá paměť: '.HumanSize(memory_get_peak_usage(FALSE)).' / '.ini_get('memory_limit').'B |';
      $Output .= '</i></div>';
    }
    $Output .= '</body></html>';
    return($Output); 
  }

  function GetOutput()
  {
    //try {
      $Output = $this->Show();
    //} catch (Exception $E) {
    //  $Output = 'Chyba: '.$E->getMessage();
    //}
    if($this->ClearPage == false) 
    {
      $Output = $this->ShowHeader($this->FullTitle, $this->ShortTitle).$Output;
      $Output .= $this->ShowFooter();
      if($this->FormatHTML == true) $Output = $this->FormatOutput($Output);
    }
    echo($Output);
  }
  
  function NewPage($ClassName)
  {
    $Page = new $ClassName();
    $Page->System = $this->System;
    $Page->Database = $this->Database;
    $Page->FormatHTML = $this->FormatHTML;
    return($Page);
  }

  // XML formating function
  function FormatOutput($s)
  {
    $out = '';
    $nn = 0;
    $n = 0;
    while($s != '')
    {
      $start = strpos($s, '<');
      $end = strpos($s, '>');
      if($start != 0)
      {
        $end = $start - 1;
        $start = 0;
      }
      $line = trim(substr($s, $start, $end + 1));
      if(strlen($line) > 0) 
      if($line[0] == '<')
      {
        if($s[$start + 1] == '/') 
        {
          $n = $n - 2;
          $nn = $n;
        } else 
        {
          if(strpos($line, ' ')) $cmd = substr($line, 1, strpos($line, ' ') - 1);
          else $cmd = substr($line, 1, strlen($line) - 2);
          //echo('['.$cmd.']');
          if(strpos($s, '</'.$cmd.'>')) $n = $n + 2;
        }   
      }// else $line = '['.$line.']';
      //if($line != '') echo(htmlspecialchars(str_repeat(' ',$nn).$line."\n"));
      if($line != '') $out .= (str_repeat(' ', $nn).$line."\n");
      $s = substr($s, $end + 1, strlen($s));
      $nn = $n;
    }
    return($out);
  }
}
