<?php

// TODO: Split all form class definitions to modules 

/*
Item definition:
Type - identifikace typu z podporovaných 
Caption - popisek, titulek položky
Default - výchozí hodnota
Null - hodnota nemusí být zadána
NoInList - sloupec viditelný v seznamu
Suffix - text za hodnotou
Description - popis významu položky
ReadOnly - je položky pouze pro čtení
Required - položka je vyžadována
*/

function RegisterFormClasses($FormManager)
{
  $FormManager->Classes = array(
  'Action' => array(
    'Title' => 'Akce',
    'Table' => 'Action',
    'Items' => array(
      //'Name' => array('Type' => 'String', 'Caption' => 'Název', 'Default' => ''),
      'Title' => array('Type' => 'String', 'Caption' => 'Název', 'Default' => ''),
      'URL' => array('Type' => 'Hyperlink', 'Caption' => 'Odkaz', 'Default' => ''),
      'Icon' => array('Type' => 'TActionIcon', 'Caption' => 'Ikony', 'Default' => '', 'Null' => true),
      'Type' => array('Type' => 'TActionType', 'Caption' => 'Typ', 'Default' => ''),
      'Group' => array('Type' => 'TActionGroup', 'Caption' => 'Skupina', 'Default' => '', 'Null' => true),
      'PermissionModule' => array('Type' => 'String', 'Caption' => 'Modul oprávnění', 'Default' => ''),
      'PermissionOperation' => array('Type' => 'String', 'Caption' => 'Operace oprávnění', 'Default' => ''),
      'Enable' => array('Type' => 'Boolean', 'Caption' => 'Povolení', 'Default' => ''),
    ),
  ),
  'ActionIcon' => array(
    'Title' => 'Ikony akcí',
    'Table' => 'ActionIcon',
    'Items' => array(
      'Name' => array('Type' => 'String', 'Caption' => 'Název souboru', 'Default' => ''),
      'Items' => array('Type' => 'TActionListIcon', 'Caption' => 'Položky', 'Default' => ''),
    ),
  ),
  'ActionGroup' => array(
    'Title' => 'Skupiny akcí',
    'Table' => 'ActionGroup',
    'Items' => array(
      'Name' => array('Type' => 'String', 'Caption' => 'Název', 'Default' => ''),
      'Items' => array('Type' => 'TActionListGroup', 'Caption' => 'Položky', 'Default' => ''),
    ),
  ),
  'ActionType' => array(
    'Title' => 'Typy akcí',
    'Table' => 'ActionType',
    'Items' => array(
      'Name' => array('Type' => 'String', 'Caption' => 'Název', 'Default' => ''),
      'Items' => array('Type' => 'TActionListType', 'Caption' => 'Položky', 'Default' => ''),
    ),
  ),
  'EmailQueue' => array(
    'Title' => 'Fronta e-mailů',
    'Table' => 'EmailQueue',
    'Items' => array(
      'Time' => array('Type' => 'DateTime', 'Caption' => 'Vytvořeno'),
      'To' => array('Type' => 'String', 'Caption' => 'Příjemce', 'Default' => ''),
      'Subject' => array('Type' => 'String', 'Caption' => 'Předmět', 'Default' => ''),
      'Content' => array('Type' => 'Text', 'Caption' => 'Obsah', 'Default' => ''),
      'Headers' => array('Type' => 'String', 'Caption' => 'Hlavička', 'Default' => ''),
      'Archive' => array('Type' => 'Boolean', 'Caption' => 'Odesláno', 'Default' => '0'),
      'From' => array('Type' => 'String', 'Caption' => 'Odesílatel', 'Default' => ''),
      'AttachmentFile' => array('Type' => 'TFile', 'Caption' => 'Příloha', 'Default' => '', 'Null' => true),
    ),
    'Actions' => array(
      array('Caption' => 'Odeslat nové', 'URL' => ''),
    ),
  ),
  'UserCustomerRel' => array(
    'Title' => 'Vztahy uživatel - zákazník',
    'Table' => 'UserCustomerRel',
    'Items' => array(
      'User' => array('Type' => 'TUser', 'Caption' => 'Uživatel', 'Default' => ''),        
      'Customer' => array('Type' => 'TMember', 'Caption' => 'Zákazník', 'Default' => ''),        
    ),
  ),
  'ServiceCustomerRel' => array(
    'Title' => 'Vztahy služba - zákazník',
    'Table' => 'ServiceCustomerRel',
    'Items' => array(
      'Service' => array('Type' => 'TService', 'Caption' => 'Služba', 'Default' => ''),        
      'Customer' => array('Type' => 'TMember', 'Caption' => 'Zákazník', 'Default' => ''),        
      'Action' => array('Type' => 'TActionEnum', 'Caption' => 'Změna období', 'Default' => '', 'Null' => true),        
      'ReplaceId' => array('Type' => 'TServiceCustomerRel', 'Caption' => 'Cílová položka', 'Default' => '', 'Null' => true),        
    ),
  ),
  'DocumentLine' => array(
    'Title' => 'Dokladové řady',
    'Table' => 'DocumentLine',
    'DefaultSortColumn' => 'Name',
    'Items' => array(
      'Name' => array('Type' => 'String', 'Caption' => 'Jméno', 'Default' => ''),        
      'Shortcut' => array('Type' => 'String', 'Caption' => 'Kód', 'Default' => ''),        
      'Sequence' => array('Type' => 'TDocumentLineSequenceListLine', 'Caption' => 'Čísleníky', 'Default' => ''),        
    ),
  ),
  'DocumentLineSequence' => array(
    'Title' => 'Čísleníky dokladových řad',
    'Table' => 'DocumentLineSequence',
    'DefaultSortColumn' => 'Id',
    'Items' => array(
      'DocumentLine' => array('Type' => 'TDocumentLine', 'Caption' => 'Dokladová řada', 'Default' => ''),        
      'FinanceYear' => array('Type' => 'TFinanceYear', 'Caption' => 'Účetní rok', 'Default' => ''),        
      'NextNumber' => array('Type' => 'Integer', 'Caption' => 'Další číslo', 'Default' => ''),        
      'YearPrefix' => array('Type' => 'Boolean', 'Caption' => 'Rok jako předpona', 'Default' => ''),        
    ),
  ),
  'FinanceYear' => array(
    'Title' => 'Účetní roky',
    'Table' => 'FinanceYear',
    'DefaultSortColumn' => 'Year',
    'Items' => array(
      'Year' => array('Type' => 'Integer', 'Caption' => 'Rok', 'Default' => ''),        
      'DateStart' => array('Type' => 'Date', 'Caption' => 'První den', 'Default' => ''),        
      'DateEnd' => array('Type' => 'Date', 'Caption' => 'Poslední den', 'Default' => ''),        
      'Sequence' => array('Type' => 'TDocumentLineSequenceListYear', 'Caption' => 'Čísleníky', 'Default' => ''),        
    ),
  ),
  'Language' => array(
    'Title' => 'Jazyky',
    'Table' => 'Language',
    'DefaultSortColumn' => 'Name',
    'Items' => array(
      'Name' => array('Type' => 'String', 'Caption' => 'Jméno', 'Default' => ''),
    ),
  ),
  'UnitOfMeasure' => array(
    'Title' => 'Měrné jednotky',
    'Table' => 'UnitOfMeasure',
    'DefaultSortColumn' => 'Name',
    'Items' => array(
      'Name' => array('Type' => 'String', 'Caption' => 'Jméno', 'Default' => ''),
      'Unit' => array('Type' => 'String', 'Caption' => 'Jednotka', 'Default' => ''),
    ),
  ),  
  'FinanceBillingPeriod' => array(
    'Title' => 'Platební období',
    'Table' => 'FinanceBillingPeriod',
    'DefaultSortColumn' => 'Name',
    'Items' => array(
      'Name' => array('Type' => 'String', 'Caption' => 'Jméno', 'Default' => ''),
      'MonthCount' => array('Type' => 'Integer', 'Caption' => 'Počet měsíců', 'Default' => '0', 'Suffix' => 'měsíců'),
    ),
  ),
  'Service' => array(
    'Title' => 'Služby',
    'Table' => 'Service',
    'DefaultSortColumn' => 'Name',
    'Items' => array(
      'Name' => array('Type' => 'String', 'Caption' => 'Jméno', 'Default' => ''),
      'Category' => array('Type' => 'TServiceCategory', 'Caption' => 'Skupina', 'Default' => '', 'Null' => true),
      'Price' => array('Type' => 'Integer', 'Caption' => 'Cena', 'Default' => '0', 'Suffix' => 'Kč'),
      'CustomerCount' => array('Type' => 'Integer', 'Caption' => 'Počet zákazníků', 'Default' => ''),
      'Public' => array('Type' => 'Boolean', 'Caption' => 'Veřejné', 'Default' => ''),
      'InternetSpeedMin' => array('Type' => 'Integer', 'Caption' => 'Min. rychlost internetu', 'Default' => '0', 'Suffix' => 'kbit/s'),
      'InternetSpeedMax' => array('Type' => 'Integer', 'Caption' => 'Max. rychlost internetu', 'Default' => '0', 'Suffix' => 'kbit/s'),
      'UploadAsymmetry' => array('Type' => 'Integer', 'Caption' => 'Asymetrie odesílání', 'Default' => '1'),
      'Memory' => array('Type' => 'Integer', 'Caption' => 'Paměť', 'Default' => '0', 'Suffix' => 'GB'),
      'MemorySwap' => array('Type' => 'Integer', 'Caption' => 'Odkládací oddíl', 'Default' => '0', 'Suffix' => 'GB'),
      'Storage' => array('Type' => 'Integer', 'Caption' => 'Úložiště', 'Default' => '0', 'Suffix' => 'GB'),
      'CPUCount' => array('Type' => 'Integer', 'Caption' => 'Počet jader', 'Default' => '0', 'Suffix' => ''),
      'Action' => array('Type' => 'TActionEnum', 'Caption' => 'Změna období', 'Default' => '', 'Null' => true),        
      'ReplaceId' => array('Type' => 'TService', 'Caption' => 'Cílová položka', 'Default' => '', 'Null' => true),
    ),
  ),
  'Country' => array(
    'Title' => 'Země',
    'Table' => 'Country',
    'DefaultSortColumn' => 'Name',
    'Items' => array(
      'Name' => array('Type' => 'String', 'Caption' => 'Jméno', 'Default' => ''),
    ),
  ),
  'NewNetworkDeviceHistory' => array(
    'Title' => 'Vložit záznam historie zařízení',
    'Table' => 'NetworkDeviceHistory',
    'Items' => array(
      'Device' => array('Type' => 'TNetworkDevice', 'Caption' => 'Zařízení', 'Default' => 0),
      'Time' => array('Type' => 'Time', 'Caption' => 'Čas', 'Default' => 'Now'),
      'Action' => array('Type' => 'TNetworkDeviceAction', 'Caption' => 'Akce', 'Default' => 0),
      'Notice' => array('Type' => 'String', 'Caption' => 'Poznámka', 'Default' => ''),
    ),
  ),
  'Email' => array(
    'Title' => 'Nový email',
    'Table' => 'EmailQueue',
    'SubmitText' => 'Odeslat',
    'Items' => array(
      'Address' => array('Type' => 'String', 'Caption' => 'Adresa', 'Default' => ''),
      'Subject' => array('Type' => 'String', 'Caption' => 'Předmět', 'Default' => ''),
      'Content' => array('Type' => 'Text', 'Caption' => 'Obsah', 'Default' => ''),
    ),
  ),
  'ServiceCategory' => array(
    'Title' => 'Kategorie služeb',
    'Table' => 'ServiceCategory',
    'Items' => array(
      'Name' => array('Type' => 'String', 'Caption' => 'Jméno', 'Default' => ''),
      'Items' => array('Type' => 'TServiceListServiceCategory', 'Caption' => 'Služby', 'Default' => ''),
    ),
  ),
);

$FormManager->FormTypes = array(
  'TServiceCategory' => array(
    'Type' => 'Reference',
    'Table' => 'ServiceCategory',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TPriority' => array(
    'Type' => 'Enumeration',
    'States' => array('Nízká', 'Střední', 'Vysoká'),
  ),
  'TNetworkConfigurationState' => array(
    'Type' => 'Enumeration',
    'States' => array('Neplánováno', 'V plánu', 'Provádí se'),
  ),    
  'TNetworkDeviceState' => array(
    'Type' => 'Enumeration',
    'States' => array('Vyřazeno', 'Použito', 'Na skladě'),
  ),
  'TNetworkDeviceAction' => array(
    'Type' => 'Enumeration',
    'States' => array('Zakoupeno', 'Prodáno', 'Zařazeno do použití', 'Vyřazeno z použití', 'Zasláno do reklamace', 'Přijato z reklamace'),
  ),
  'TActionEnum' => array(
    'Type' => 'Enumeration',
    'States' => array('add' => 'Přidat', 'modify' => 'Upravit', 'remove' => 'Odstranit'),
  ),    
  'TService' => array(
    'Type' => 'Reference',
    'Table' => 'Service',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TFinanceBillingPeriod' => array(
    'Type' => 'Reference',
    'Table' => 'FinanceBillingPeriod',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TMember' => array(
    'Type' => 'Reference',
    'Table' => 'Member',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TMemberListSubject' => array(
    'Type' => 'ManyToOne',
    'Table' => 'Member',
    'Id' => 'Id',
    'Ref' => 'Subject',
    'Filter' => '1',
  ),
  'TMapPosition' => array(
    'Type' => 'Reference',
    'Table' => 'MapPosition',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TUser' => array(
    'Type' => 'Reference',
    'Table' => 'User',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TFinanceSubject' => array(
    'Type' => 'Reference',
    'Table' => 'Subject',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TDocumentLine' => array(
    'Type' => 'Reference',
    'Table' => 'DocumentLine',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TBankAccount' => array(
    'Type' => 'Reference',
    'Table' => 'FinanceBankAccount',
    'Id' => 'Id',
    'Name' => 'CONCAT(`Comment`, " (", `Number`, "/", '. 
      '(SELECT `FinanceBank`.`Code` FROM `FinanceBank` WHERE `FinanceBank`.`Id`=`FinanceBankAccount`.`Bank`), ")")',
    'Filter' => '1',
  ),
  'TNetworkDevice' => array(
    'Type' => 'Reference',
    'Table' => 'NetworkDevice',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TNetworkDeviceType' => array(
    'Type' => 'Reference',
    'Table' => 'NetworkDeviceType',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TNetworkInterface' => array(
    'Type' => 'Reference',
    'Table' => 'NetworkInterface',
    'View' => '(SELECT NetworkInterface.*, CONCAT(NetworkDevice.Name, "-", NetworkInterface.Name) AS DeviceName FROM NetworkInterface '.
      'LEFT JOIN NetworkDevice ON NetworkDevice.Id = NetworkInterface.Device) AS T',      
    'Id' => 'Id',
    'Name' => 'DeviceName',
    'Filter' => '1',
  ),
  'TNetworkInterfaceType' => array(
    'Type' => 'Reference',
    'Table' => 'NetworkInterfaceType',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TServiceCustomerRel' => array(
    'Type' => 'Reference',
    'Table' => 'ServiceCustomerRel',
    'Id' => 'Id',
    'Name' => 'Id',
    'Filter' => '1',
  ),
  'TNetworkSegment' => array(
    'Type' => 'Reference',
    'Table' => 'NetworkSegment',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TNewsCategory' => array(
    'Type' => 'Reference',
    'Table' => 'NewsCategory',
    'Id' => 'Id',
    'Name' => 'Caption',
    'Filter' => '1',
  ),
  'TCountry' => array(
    'Type' => 'Reference',
    'Table' => 'Country',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TSubject' => array(
    'Type' => 'Reference',
    'Table' => 'Subject',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TFinanceTreasury' => array(
    'Type' => 'Reference',
    'Table' => 'FinanceTreasury',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TFinanceBankAccount' => array(
    'Type' => 'Reference',
    'Table' => 'FinanceBankAccount',
    'Id' => 'Id',
    'Name' => 'Comment',
    'Filter' => '1',
  ),
  'TFile' => array(
    'Type' => 'Reference',
    'Table' => 'File',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TTaskList' => array(
    'Type' => 'ManyToOne',
    'Table' => 'Task',
    'Id' => 'Id',
    'Ref' => 'Group',
    'Filter' => '1',
  ),
  'TDeviceList' => array(
    'Type' => 'ManyToOne',
    'Table' => 'NetworkDevice',
    'Id' => 'Id',
    'Ref' => 'Member',
    'Filter' => '1',
  ),
  'TInterfaceList' => array(
    'Type' => 'ManyToOne',
    'Table' => 'NetworkInterface',
    'Id' => 'Id',
    'Ref' => 'Device',
    'Filter' => '1',
  ),
  'TProduct' => array(
    'Type' => 'Reference',
    'Table' => 'Product',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TTaskGroup' => array(
    'Type' => 'Reference',
    'Table' => 'TaskGroup',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TStock' => array(
    'Type' => 'Reference',
    'Table' => 'Stock',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TFinanceBank' => array(
    'Type' => 'Reference',
    'Table' => 'FinanceBank',
    'Id' => 'Id',
    'Name' => 'CONCAT(Name, " (", Code, ")")',
    'Filter' => '1',
  ),
  'TUnitOfMeasure' => array(
    'Type' => 'Reference',
    'Table' => 'UnitOfMeasure',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TLanguage' => array(
    'Type' => 'Reference',
    'Table' => 'Language',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TAction' => array(
    'Type' => 'Reference',
    'Table' => 'Action',
    'Id' => 'Id',
    'Name' => 'Title',
    'Filter' => '1',
  ),
  'TActionIcon' => array(
    'Type' => 'Reference',
    'Table' => 'ActionIcon',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TActionType' => array(
    'Type' => 'Reference',
    'Table' => 'ActionType',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TActionGroup' => array(
    'Type' => 'Reference',
    'Table' => 'ActionGroup',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TDirectory' => array(
    'Type' => 'Reference',
    'Table' => 'FileDirectory',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TTVGroup' => array(
    'Type' => 'Reference',
    'Table' => 'TVGroup',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TStockItemListStock' => array(
    'Type' => 'ManyToOne',
    'Table' => 'StockItem',
    'Id' => 'Id',
    'Ref' => 'Stock',
    'Filter' => '1',
  ),
  'TStockItemListProduct' => array(
    'Type' => 'ManyToOne',
    'Table' => 'StockItem',
    'Id' => 'Id',
    'Ref' => 'Product',
    'Filter' => '1',
  ),   
  'TDocumentLine' => array(
    'Type' => 'Reference',
    'Table' => 'DocumentLine',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),   
  'TFinanceYear' => array(
    'Type' => 'Reference',
    'Table' => 'FinanceYear',
    'Id' => 'Id',
    'Name' => 'Year',
    'Filter' => '1',
  ),
  'TTask' => array(
    'Type' => 'Reference',
    'Table' => 'Task',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TCurrency' => array(
    'Type' => 'Reference',
    'Table' => 'Currency',
    'Id' => 'Id',
    'Name' => 'Code',
    'Filter' => '1',
  ),
  'TMenuItem' => array(
    'Type' => 'Reference',
    'Table' => 'MenuItem',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TMenu' => array(
    'Type' => 'Reference',
    'Table' => 'Menu',
    'Id' => 'Id',
    'Name' => 'Name',
    'Filter' => '1',
  ),
  'TFinanceInvoice' => array(
    'Type' => 'Reference',
    'Table' => 'FinanceInvoice',
    'Id' => 'Id',
    'Name' => 'BillCode',
    'Filter' => '1',
  ),
  'TFinanceOperation' => array(
    'Type' => 'Reference',
    'Table' => 'FinanceOperation',
    'Id' => 'Id',
    'Name' => 'BillCode',
    'Filter' => '1',
  ),
  'TPermissionGroup' => array(
    'Type' => 'Reference',
    'Table' => 'PermissionGroup',
    'Id' => 'Id',
    'Name' => 'Description',
    'Filter' => '1',
  ),
  'TPermissionGroupAssignment' => array(
    'Type' => 'Reference',
    'Table' => 'PermissionGroupAssignment',
    'Id' => 'Id',
    'Name' => 'Id',
    'Filter' => '1',
  ),
  'TPermissionOperation' => array(
    'Type' => 'Reference',
    'Table' => 'PermissionOperation',
    'Id' => 'Id',
    'Name' => 'Id',
    'Filter' => '1',
  ),
  'TFinanceCharge' => array(
    'Type' => 'Reference',
    'Table' => 'FinanceCharge',
    'Id' => 'Id',
    'Name' => 'Id',
    'Filter' => '1',
  ),
  'TDocumentLineSequenceListYear' => array(
    'Type' => 'ManyToOne',
    'Table' => 'DocumentLineSequence',
    'Id' => 'Id',
    'Ref' => 'FinanceYear',
    'Filter' => '1',
  ),
  'TDocumentLineSequenceListLine' => array(
    'Type' => 'ManyToOne',
    'Table' => 'DocumentLineSequence',
    'Id' => 'Id',
    'Ref' => 'DocumentLine',
    'Filter' => '1',
  ),
  'TWorkListTask' => array(
    'Type' => 'ManyToOne',
    'Table' => 'Work',
    'Id' => 'Id',
    'Ref' => 'Task',
    'Filter' => '1',
  ),
  'TUserCustomerRelListUser' => array(
    'Type' => 'ManyToOne',
    'Table' => 'UserCustomerRel',
    'Id' => 'Id',
    'Ref' => 'User',
    'Filter' => '1',
  ),
  'TUserCustomerRelListCustomer' => array(
    'Type' => 'ManyToOne',
    'Table' => 'UserCustomerRel',
    'Id' => 'Id',
    'Ref' => 'Customer',
    'Filter' => '1',
  ),
  'TServiceCustomerRelListCustomer' => array(
    'Type' => 'ManyToOne',
    'Table' => 'ServiceCustomerRel',
    'Id' => 'Id',
    'Ref' => 'Customer',
    'Filter' => '1',
  ),
  'TPermissionUserAssignmentListUser' => array(
    'Type' => 'ManyToOne',
    'Table' => 'PermissionUserAssignment',
    'Id' => 'Id',
    'Ref' => 'User',
    'Filter' => '1',
  ),
  'TPermissionGroupAssignmentListGroup' => array(
    'Type' => 'ManyToOne',
    'Table' => 'PermissionGroupAssignment',
    'Id' => 'Id',
    'Ref' => 'Group',
    'Filter' => '1',
  ),
  'TPermissionGroupAssignmentListOperation' => array(
    'Type' => 'ManyToOne',
    'Table' => 'PermissionGroupAssignment',
    'Id' => 'Id',
    'Ref' => 'AssignedOperation',
    'Filter' => '1',
  ),
  'TPermissionGroupAssignmentListAssignedGroup' => array(
    'Type' => 'ManyToOne',
    'Table' => 'PermissionGroupAssignment',
    'Id' => 'Id',
    'Ref' => 'AssignedGroup',
    'Filter' => '1',
  ),
  'TServiceListServiceCategory' => array(
    'Type' => 'ManyToOne',
    'Table' => 'Service',
    'Id' => 'Id',
    'Ref' => 'Category',
    'Filter' => '1',
  ),
  'TNetworkLinkListInterface1' => array(
    'Type' => 'ManyToOne',
    'Table' => 'NetworkLink',
    'Id' => 'Id',
    'Ref' => 'Interface1',
    'Filter' => '1',
  ),
  'TNetworkLinkListInterface2' => array(
    'Type' => 'ManyToOne',
    'Table' => 'NetworkLink',
    'Id' => 'Id',
    'Ref' => 'Interface2',
    'Filter' => '1',
  ),
  'TFinanceInvoiceItemListInvoice' => array(
    'Type' => 'ManyToOne',
    'Table' => 'FinanceInvoiceItem',
    'Id' => 'Id',
    'Ref' => 'FinanceInvoice',
    'Filter' => '1',
  ),
  'TFinanceOperationListAccount' => array(
    'Type' => 'ManyToOne',
    'Table' => 'FinanceOperation',
    'Id' => 'Id',
    'Ref' => 'BankAccount',
    'Filter' => '1',
  ),
  'TFinanceOperationListSubject' => array(
    'Type' => 'ManyToOne',
    'Table' => 'FinanceOperation',
    'Id' => 'Id',
    'Ref' => 'Subject',
    'Filter' => '1',
  ),
  'TFinanceInvoiceListSubject' => array(
    'Type' => 'ManyToOne',
    'Table' => 'FinanceInvoice',
    'Id' => 'Id',
    'Ref' => 'Subject',
    'Filter' => '1',
  ),
  'TMenuItemListMenu' => array(
    'Type' => 'ManyToOne',
    'Table' => 'MenuItem',
    'Id' => 'Id',
    'Ref' => 'Menu',
    'Filter' => '1',
  ),
  'TMenuItemListParent' => array(
    'Type' => 'ManyToOne',
    'Table' => 'MenuItem',
    'Id' => 'Id',
    'Ref' => 'Parent',
    'Filter' => '1',
  ),
  'TActionListGroup' => array(
    'Type' => 'ManyToOne',
    'Table' => 'Action',
    'Id' => 'Id',
    'Ref' => 'Group',
    'Filter' => '1',
  ),
  'TActionListIcon' => array(
    'Type' => 'ManyToOne',
    'Table' => 'Action',
    'Id' => 'Id',
    'Ref' => 'Icon',
    'Filter' => '1',
  ),
  'TActionListType' => array(
    'Type' => 'ManyToOne',
    'Table' => 'Action',
    'Id' => 'Id',
    'Ref' => 'Type',
    'Filter' => '1',
  ),
);
}
