<?php

class Bill extends Module
{
  var $SpecificSymbol = 1; // počítačová sít

  function GenerateHTML()
  {
    return('');
  }

  function SaveToFile($FileName)
  {
    global $Database;

    $PdfData = $this->HtmlToPdf($this->GenerateHTML());
    file_put_contents($FileName, $PdfData);
  }

  function HtmlToPdf($HtmlCode)
  {
    $Output = shell_exec('echo "'.addslashes(FromUTF8($HtmlCode)).
      '"|htmldoc --no-numbered --webpage --no-embedfonts --charset 8859-2 -t pdf -');
    return($Output);
  }
}

class BillInvoice extends Bill
{
  var $InvoiceId;  

  function GenerateHTML()
  {
    global $SpecificSymbol, $Config;
    
    $DbResult = $this->Database->select('FinanceInvoice', '*', '`Id`='.$this->InvoiceId);
    $Invoice = $DbResult->fetch_assoc();
   
    $DbResult = $this->Database->select('Subject', '*', '`Id`='.$Invoice['Subject']);
    $Subject = $DbResult->fetch_assoc();
    
    $DbResult = $this->Database->select('Subject', '*', '`Id`='.$Config['Finance']['MainSubjectId']);
    $MainSubject = $DbResult->fetch_assoc();
    
    $DbResult = $this->Database->query('SELECT FinanceBankAccount.*, CONCAT(FinanceBankAccount.Number, "/", FinanceBank.Code) AS NumberFull FROM FinanceBankAccount '.
      'JOIN FinanceBank ON FinanceBank.Id=FinanceBankAccount.Bank '.
      'WHERE (FinanceBankAccount.`Subject`='.$Config['Finance']['MainSubjectId'].') AND (FinanceBankAccount.`Use`=1)');
    $MainSubjectAccount = $DbResult->fetch_assoc();
    
    $Dodavka = array();
    $DbResult = $this->Database->select('FinanceInvoiceItem', '*', 'FinanceInvoice='.$this->InvoiceId);
    while($Item = $DbResult->fetch_assoc())
    {
      $InvoiceItems[$Item['Id']] = $Item;
    }
    
    $PaymentType = array('převodem', 'hotově');
    $BooleanText = array('Ne', 'Ano');

    $Output = '<table width="100%"><tr><td colspan="2">'.
      '<font size="6"><div align="center">Faktura - daňový doklad</font></div>'.
      '<hr></td></tr>'.
      '<tr><td valign="top" width="50%"><strong>Dodavatel:</strong><br>'.
      $MainSubject['Name'].'<br>'.
      $MainSubject['AddressStreet'].'<br>'.
      $MainSubject['AddressPSC'].' '.$MainSubject['AddressTown'].'<br>'.
      'IČ: '.$MainSubject['IC'].'<br>'.
      'DIČ: '.$MainSubject['DIC'].'<br>'.
      'Účet: '.$MainSubjectAccount['NumberFull'].'<br>'.
      'Plátce DPH: '.$BooleanText[$MainSubject['PayVAT']].'<br>'.
      '</td><td valign="top">'.
      '<strong>Odběratel:</strong><br>'.
      $Subject['Name'].'<br>'.
      $Subject['AddressStreet'].'<br>'.
      $Subject['AddressPSC'].' '.$Subject['AddressTown'].'<br>';
      if($Subject['IC'] != 0) $Output .= 'IČ: '.$Subject['IC'].'<br>';
      if($Subject['DIC'] != '') $Output .= 'DIČ: '.$Subject['DIC'].'<br>';
    $Output .=
      '</td></tr>'.
      '<tr><td colspan="2"><hr></td></tr>'.
      '<tr><td width="50%" valign="top">'.
      '<strong>Platební podmínky:</strong><br>'.
      'Číslo dokladu: '.$Invoice['BillCode'].'<br>'.
      'Variabilní symbol: '.$Subject['Id'].'<br>'.
      'Specifický symbol: '.$this->SpecificSymbol.'<br>'.
      'Konstantní symbol:<br>'.
      'Způsob úhrady: '.$PaymentType[$Invoice['Cash']].
      '</td><td valign="top">'.
      '<br>'.
      'Datum vystavení: '.HumanDate($Invoice['TimeCreation']).'<br>'.
      'Datum zdanitel. plnění: '.HumanDate($Invoice['TimeCreation']).'<br>'.
      'Datum splatnosti: '.HumanDate($Invoice['TimeDue']).'<br>';
    if(($Invoice['PeriodFrom'] != '') and ($Invoice['PeriodTo'] != ''))
      $Output .= 'Fakturované období: '.HumanDate($Invoice['PeriodFrom']).' - '.
        HumanDate($Invoice['PeriodTo']).'<br>';
    $Output .= '</td></tr>'.
      '<tr><td colspan="2">'.
      '<hr>'.
      '<br>'.
      '<table border="0" width="100%">'.
      '<tr><th align="left">Dodávka</th><th align="right">Množství</th><th align="right">Cena/MJ</th><th align="right">Celkem</th></tr>'.
      '<tr><td colspan="4"><hr></td></tr>';
    
    $Total = 0;
    foreach($InvoiceItems as $Item)
    {
      $Output .= '<tr><td>'.$Item['Description'].'</td><td align="right">'.
        $Item['Quantity'].'</td><td align="right">'.$Item['Price'].
        '&nbsp;Kč</td><td align="right">'.($Item['Quantity'] * $Item['Price']).'&nbsp;Kč</td></tr>';
      $Total += ($Item['Quantity'] * $Item['Price']);
    }
    $Output .= '<tr><th colspan="3" align="left">Celkem</th><th align="right">'.$Total.'&nbsp;Kč</th></tr>';
    $Output .= '</table>'.
      '</td></tr>'.
      '<tr><td colspan="2"><hr></td></tr>'.
      '</table>';
      
    return($Output);
  }
}

class BillOperation extends Bill
{
  var $OperationId;  
  
  function GenerateHTML()
  {
    $DbResult = $this->Database->select('FinanceOperation', '*', '`Id`='.$this->OperationId);
    $Operation = $DbResult->fetch_assoc();
   
    $DbResult = $this->Database->select('Subject', '*', '`Id`='.$Operation['Subject']);
    $Subject = $DbResult->fetch_assoc();
    
    $DbResult = $this->Database->select('Subject', '*', '`Id`='.$Config['Finance']['MainSubjectId']);
    $MainSubject = $DbResult->fetch_assoc();
    
    $DbResult = $this->Database->query('SELECT FinanceBankAccount.*, CONCAT(FinanceBankAccount.Number, "/", FinanceBank.Code) AS NumberFull FROM FinanceBankAccount '.
      'JOIN FinanceBank ON FinanceBank.Id=FinanceBankAccount.Bank '.
      'WHERE (FinanceBankAccount.`Subject`='.$Config['Finance']['MainSubjectId'].') AND (FinanceBankAccount.`Use`=1)');
    $MainSubjectAccount = $DbResult->fetch_assoc();
    
    //$Dodavka = array();
    //$DbResult = $this->Database->select('FinanceInvoiceItem', '*', 'FinanceInvoice='.$BillId);
    //while($Item = $DbResult->fetch_assoc())
    //{
    //  $InvoiceItems[$Item['Id']] = $Item;
    //}

    $Output = '<table width="100%" border="1" cellspacing="0" cellpadding="3"><tr><td width="50%">'.
      '<strong>Firma:</strong><br>'.
      $MainSubject['Name'].'<br>'.
      $MainSubject['AddressStreet'].'<br>'.
      $MainSubject['AddressPSC'].' '.$MainSubject['AddressTown'].'<br>'.
      'IČ: '.$MainSubject['IC'].'<br>'.
      'DIČ: '.$MainSubject['DIC'].'<br>'.
      'Účet: '.$MainSubjectAccount['NumberFull'].'<br>'.
      'Plátce DPH: '.$BooleanText[$MainSubject['PayVAT']].
      '</td><td width="50%" valign="top">'.
      '<font size="5"><strong>PŘÍJMOVÝ POKLADNÍ DOKLAD</strong></font><br><br>'.
      'Číslo dokladu: '.$Bill['BillCode'].'<br>'.
      'Datum vystavení: '.HumanDate($Bill['TimeCreate']).'<br>'.
      '</td></tr>'.
      '<tr><td colspan="2"><strong>Přijato od:</strong><br>'.
      $Subject['Name'].'<br>'.
      $Subject['AddressStreet'].'<br>'.
      $Subject['AddressPSC'].' '.$Subject['AddressTown'].'<br>';
    if($Subject['IC'] != 0) $Output .= 'IČ: '.$Subject['IC'].'<br>';
    if($Subject['DIC'] != '') $Output .= 'DIČ: '.$Subject['DIC'].'<br>';
    $Total = 0;
    $Description = '';
    //foreach($Dodavka as $Polozka)
    //{
    //  $Description .= $Polozka['Description'].'<br>';
    //  $Total += ($Polozka['Quantity'] * $Polozka['Price']);
    //}
    $Output .= '</td></tr>'.
      '<tr><td colspan="2"><strong>Částka:</strong> '.$Total.' Kč<br><br>'.
      '</td></tr>'.
      '<tr><td colspan="2"><strong>Účel platby:</strong><br>'.$Description.'</td></tr>'.
      '<tr><td><br><br>Podpis příjemce:</td><td><br><br>Podpis pokladníka:</td></tr>';
    $Output .= '</table>';
    return($Output);
  }
}
