<?php

class PageFinanceManage extends Page
{
  var $FullTitle = 'Správa financí';
  var $ShortTitle = 'Správa financí';
  var $ParentClass = 'PageFinance';
  
  function Show()
  {
    if(!$this->System->User->CheckPermission('Finance', 'Manage')) 
      return('Nemáte oprávnění');

    if(array_key_exists('Operation', $_GET)) $Operation = $_GET['Operation']; 
      else $Operation = '';
    //$Operation = 'ImportOldData';
    switch($Operation)
    {
      case 'Bills':
        $Output = $this->BillManage();
        break;
      case 'ConvertPDFToFile':
        $Output = $this->ConvertPDFDataToFiles();
        break;
      //case 'ImportOldData':
      //  $Output = $this->ImportOldData();
      //  break;
      case 'NewPaymentInsert':
        $Output = $this->ShowNewPaymentInsert();
        break;
      case 'NewPaymentForm':
        $Output = $this->ShowNewPaymentForm();
        break;
      case 'NewInvoiceInsert':
        $Output = $this->ShowNewInvoiceInsert();
        break;
      case 'NewInvoiceForm':
        $Output = $this->ShowNewInvoiceForm();
        break;
      case 'Recalculate':
        $Output = $this->System->Modules['Finance']->RecalculateSegmentParameters();
        $Output .= $this->System->Modules['Finance']->RecalculateMemberPayment();
        break;
      case 'ShowMonthlyPayment':
        $Output = $this->ShowMonthlyPayment();
        break;
      case 'ProcessMonthlyPayment':
        $Output = $this->ProcessMonthlyPayment();
        break;
      case 'GenerateBills':
        $Output = $this->GenerateBills();
        break;
      default:
        $Output = '<a href="?Operation=NewPaymentForm">Přidat novou platbu</a><br />';
        $Output .= '<a href="?Operation=NewInvoiceForm">Přidat novou fakturu</a><br />';
        $Output .= '<a href="?Operation=ConvertPDFToFile">Převést data z databáze do souborů</a><br />';
        $Output .= '<a href="?Operation=Bills">Správa dokladů</a><br />';
        //$Output .= '<a href="?Operation=Recalculate">Přepočet financí</a><br />';
        $Output .= '<a href="?Operation=ShowMonthlyPayment">Měsíční vyúčtování</a><br />';
        //$Output .= '<a href="clenove.php">Seznam členů</a><br />';
        $Output .= '<a href="'.$this->System->Link('/finance/zivnost/').'">Živnost</a><br />';
        $Output .= '<a href="?Operation=GenerateBills">Generovat chybějící doklady</a><br />';
        $Output .= '<a href="'.$this->System->Link('/finance/import/').'">Import plateb</a><br />';
    }
    return($Output);
  }

  function BillManage()
  {
    $Output = '';
    if(array_key_exists('subject', $_GET))
    {
      $DbResult = $this->Database->select('FinanceBills', '*', 'Subject='.$_GET['subject']);
      while($Item = $DbResult->fetch_array())
      {
        $Output .= '<a href="?Operation=Bills&amp;bill='.$Item['Id'].'">faktura '.$Item['Id'].'</a> <a href="?Operation=Bills&amp;billpdf='.$Item['Id'].'">Uložené PDF</a> <a href="?Operation=Bills&amp;billpdf2='.$Item['Id'].'">Generované PDF</a> <a href="?Operation=Bills&amp;regenerate='.$Item['Id'].'">Přegenerovat</a><br />';
      }
    } else
    if(array_key_exists('billpdf', $_GET))
    {
      $Output .= $this->System->Modules['Bill']->ShowStoredBill($_GET['billpdf']);
    } else
    if(array_key_exists('billpdf2', $_GET))
    {
      $Output .= $this->System->Modules['Bill']->ShowGeneratedBill($_GET['billpdf2']);
    } else
    if(array_key_exists('regenerate', $_GET))
    {
      $Output .= $this->System->Modules['Bill']->RegeneratePDF($_GET['regenerate']);
    } else
    if(array_key_exists('bill', $_GET))
    {
      $Output .= $this->System->Modules['Bill']->GenerateBill($_GET['bill']);
    } else
    if(array_key_exists('generate', $_GET))
    {
      $Output .= $this->System->Modules['Bill']->CreateBill(1, array(array('Description' => 'Poplatek za připojení k Internetu', 'Price' => 1000, 'Quantity' => 1)), time(), time());
    } else 
    {
      //ShowHeader('Faktury', 'Faktury');
      $Output .= 'Faktury:<br />';
      $DbResult = $this->Database->select('Subject', '*', '1 ORDER BY Name');
      while($Subject = $DbResult->fetch_array())
      {
        $Output .= '<a href="?Operation=Bills&amp;subject='.$Subject['Id'].'">'.$Subject['Name'].'</a><br />';
      }
      //ShowFooter();
    }
    return($Output);
  }

  function CheckAdvancesAndLiabilities($Subject)
  {
    global $LastInsertTime;

    do {
      $DbResult = $this->Database->select('FinanceAdvances', 'SUM(Value)', 'Subject='.$Subject.' AND Direction = "In"');
      $DbRow = $DbResult->fetch_array();
      $Advances = $DbRow[0];
      $DbResult = $this->Database->select('FinanceInvoice', '*', 'Subject='.$Subject.
      ' AND TimePayment IS NULL AND Value > 0 ORDER BY TimeCreation LIMIT 1');
      if($DbResult->num_rows > 0)
      {
        $OpenedClaim = $DbResult->fetch_array();
        if($Advances > $OpenedClaim['Value'])
        {
          $this->Database->update('FinanceInvoice', 'Id='.$OpenedClaim['Id'], 
            array('TimePayment' => TimeToMysqlDateTime($LastInsertTime)));
          $this->Database->insert('FinanceAdvances', array('Subject' => 
            $OpenedClaim['Subject'], 'Value' => -$OpenedClaim['Value'], 
            'TimeCreation' => TimeToMysqlDateTime($LastInsertTime), 
            'CashFlowId' => $OpenedClaim['Id'], 'Direction' => 'In'));
        } else break;
      } else break;
    } while(($Advances > $OpenedClaim['Value']));
  }

  function InsertInvoice($Subject, $TimeCreation, $TimeDue, $Items, 
    $DocumentLine, $PeriodFrom, $PeriodTo)
  {
    global $LastInsertTime;

    $BillCode = $this->System->Modules['Finance']->GetNextDocumentLineNumber($DocumentLine);
    $SumValue = 0;
    foreach($Items as $Item)
      $SumValue = $SumValue + $Item['Price'];
    $this->Database->insert('FinanceInvoice', array( 
      'Subject' => $Subject, 'TimeCreation' => TimeToMysqlDateTime($TimeCreation), 
      'TimeDue' => TimeToMysqlDateTime($TimeDue), 'Value' => $SumValue, 'BillCode' => $BillCode,
      'PeriodFrom' => TimeToMysqlDate($PeriodFrom), 'PeriodTo' => TimeToMysqlDate($PeriodTo)));
    $InvoiceId = $this->Database->insert_id;
    foreach($Items as $Item)
    $this->Database->insert('FinanceInvoiceItem', array('FinanceInvoice' => $InvoiceId, 
      'Description' => $Item['Description'], 'Price' => $Item['Price'], 'Quantity' => $Item['Quantity'], 'VAT' => $Item['VAT']));
    //$LastInsertTime = $Time;
    //$this->CheckAdvancesAndLiabilities($Subject);
    return($InvoiceId);
  }

  function InsertMoney($Subject, $Value, $Cash, $Taxable, $Time, $Text, $DocumentLine)
  {
    global $LastInsertTime;

    $BillCode = $this->System->Modules['Finance']->GetNextDocumentLineNumber($DocumentLine);
    $this->Database->insert('FinanceOperation', array('Text' => $Text, 'Subject' => $Subject, 'Cash' => $Cash, 'Value' => $Value, 'Time' => TimeToMysqlDateTime($Time), 'Taxable' => $Taxable, 'BillCode' => $BillCode));
    /*if($Value >= 0)
    {
      $this->Database->insert('FinanceAdvances', array('Subject' => $Subject, 'Value' => $Value, 'TimeCreation' => TimeToMysqlDateTime($Time), 'CashFlowId' => $this->Database->insert_id, 'Direction' => 'In'));
    }
    $LastInsertTime = $Time;
    */
    //$this->CheckAdvancesAndLiabilities($Subject);
  }

    function ShowNewPaymentForm()
  {
    $Form = new Form($this->System->FormManager);
    $Form->SetClass('NewPayment');
    $Form->OnSubmit = '?Operation=NewPaymentInsert';
    $Output = $Form->ShowEditForm();
    return($Output);
  }

  function ShowNewPaymentInsert()
  {
    $Form = new Form($this->System->FormManager);
    $Form->SetClass('NewPayment');
    $Form->LoadValuesFromForm();
    $this->InsertMoney($Form->Values['Subject'], $Form->Values['Value'], $Form->Values['Cash'], $Form->Values['Taxable'], $Form->Values['Time'], $Form->Values['Text'], $Form->Values['DocumentLine']);
    $LastId = $this->Database->insert_id;
    $DbResult = $this->Database->select('FinanceOperation', 'BillCode', 'Id='.$LastId);
    $DbRow = $DbResult->fetch_assoc();
    $Output = $this->SystemMessage('Finance', 'Platba vložena '.$DbRow['BillCode'].'.');
    $this->System->ModuleManager->Modules['Log']->NewRecord('Finance', 'NewPaymentInserted');
    return($Output);
  }

  function ShowNewInvoiceForm()
  {
    $Form = new Form($this->System->FormManager);
    $Form->SetClass('NewInvoice');
    $Form->OnSubmit = '?Operation=NewInvoiceInsert';
    $Output = $Form->ShowEditForm();
    return($Output);
  }

  function ShowNewInvoiceInsert()
  {
    $Form = new Form($this->System->FormManager);
    $Form->SetClass('NewInvoice');
    $Form->LoadvaluesFromForm();
    $Items = array(array('Price' => $Form->Values['Value'], 
      'Description' => $Form->Values['Text'], 'Quantity' => 1, 'VAT' => 21));
    $LastId = $this->InsertInvoice($Form->Values['Subject'],  
      $Form->Values['TimeCreation'], $Form->Values['TimeDue'], $Items, 
      $Form->Values['DocumentLine'], NULL, NULL);
    $DbResult = $this->Database->select('FinanceInvoice', 'BillCode', 'Id='.$LastId);
    $DbRow = $DbResult->fetch_assoc();
    $Output = $this->SystemMessage('Finance', 'Faktura vložena '.$DbRow['BillCode'].'.');
    $this->System->ModuleManager->Modules['Log']->NewRecord('Finance', 'NewInvoiceInserted');
    return($Output);
  }
  
  function ConvertPDFDataToFiles()
  {
    $DbResult = $this->Database->query('SELECT * FROM FinanceBills');
    while($Bill = $DbResult->fetch_assoc())
    {
      file_put_contents('doklady/doklad_'.$Bill['id'].'.pdf', $Bill['pdf']);
      echo($Bill['id'].',');
    }
  }

  function CheckPDFFiles()
  {
    global $InvoiceGenerator;

    $DbResult = $this->Database->query('SELECT * FROM FinanceBills');
    while($Bill = $DbResult->fetch_assoc())
    {
      file_put_contents('doklady2/doklad-'.$Bill['id'].'.pdf', file_get_contents('doklady/doklad-'.$Bill['id'].'.pdf'));
      //echo($InvoiceGenerator->HasPDFFile($Bill['id']).',');
    }
  }
  
  function GetBillingPeriod($Period)
  {
    $MonthCount = $this->System->Modules['Finance']->BillingPeriods[$Period]['MonthCount'];
    $PeriodFrom = mktime(0, 0, 0, date('n'), 1, date('Y'));
    $PeriodTo = mktime(0, 0, 0, date('n') + $MonthCount - 1, date('t', mktime(0, 0, 0, date('n') + $MonthCount - 1, 1, date('Y'))) , date('Y'));
    return(array('From' => $PeriodFrom, 'To' => $PeriodTo, 'MonthCount' => $MonthCount));
  } 

  function ShowMonthlyPayment()
  {
    if(!$this->System->User->CheckPermission('Finance', 'Manage')) return('Nemáte oprávnění');
    $SQL = 'SELECT Member.*, MemberPayment.MonthlyTotal AS Monthly, '.
      'MemberPayment.Cash AS Cash, '.
      '(SELECT GROUP_CONCAT(Service.Name) FROM ServiceCustomerRel LEFT JOIN Service '.
      'ON Service.Id=ServiceCustomerRel.Service WHERE ServiceCustomerRel.Customer=Member.Id AND '.
      'ServiceCustomerRel.Action IS NULL) AS ServicesNextMonth, '.
      'UNIX_TIMESTAMP(Member.BillingPeriodLastDate) AS LastDate, Subject.Name AS SubjectName, '.
      'FinanceBillingPeriod.Name AS BillingPeriodName '.
      'FROM MemberPayment JOIN Member ON Member.Id=MemberPayment.Member JOIN Subject '.
      'ON Subject.Id=Member.Subject LEFT JOIN FinanceBillingPeriod ON '.
      'FinanceBillingPeriod.Id=Member.BillingPeriodNext WHERE (Member.Blocked = 0)'.
      'AND (Member.BillingPeriodNext > 1) AND (MemberPayment.MonthlyTotal != 0)';
    
    $DbResult = $this->Database->query('SELECT COUNT(*) FROM ('.$SQL.') AS T');
    $DbRow = $DbResult->fetch_row();
    $PageList = GetPageList($DbRow[0]);    

    $Output = $PageList['Output'];
    $Output .= '<table class="WideTable" style="font-size: small;">';
   
    $TableColumns = array(
      array('Name' => 'SubjectName', 'Title' => 'Jméno'), 
      array('Name' => 'Monthly', 'Title' => 'Platba'), 
      array('Name' => 'Cash', 'Title' => 'Kredit'), 
      array('Name' => 'LastDate', 'Title' => 'Poslední fakturace'), 
      array('Name' => 'ServicesNextMonth', 'Title' => 'Služby'), 
      array('Name' => 'BillingPeriodName', 'Title' => 'Perioda'), 
    );
    $Order = GetOrderTableHeader($TableColumns, 'SubjectName', 0);
    $Output .= $Order['Output'];

    $Query = $SQL.' '.$Order['SQL'].$PageList['SQLLimit'];
   
    $DbResult = $this->Database->query($Query);
    while($Row = $DbResult->fetch_assoc()) 
    { 
      $Output .= '<tr>'.
      '<td>'.$Row['SubjectName'].'</td>'.
      '<td>'.$Row['Monthly'].'</td>'.
      '<td>'.$Row['Cash'].'</td>'.
      '<td>'.date('j.n.Y', $Row['LastDate']).'</td>'.
      '<td>'.$Row['ServicesNextMonth'].'</td>'.
      '<td>'.$Row['BillingPeriodName'].'</td>'.
      '</tr>';
    }
    $Output .= '</table>';
    $Output .= $PageList['Output'];
    $Output .= '<a href="?Operation=ProcessMonthlyPayment">Generovat faktury</a>';
    return($Output);
  }
  
  function ProduceInvoices()
  {
    $Output = '';
    
    // Generuj účetní položky
    $DbResult = $this->Database->query('SELECT Member.*, MemberPayment.MonthlyTotal AS MonthlyTotal, '.
      'UNIX_TIMESTAMP(Member.BillingPeriodLastDate), Subject.Name AS SubjectName,'.
      'MemberPayment.MonthlyPlus AS MonthlyPlus '.
      'FROM MemberPayment JOIN Member ON Member.Id=MemberPayment.Member '.
      'JOIN Subject ON Subject.Id=Member.Subject');
    while($Member = $DbResult->fetch_assoc())
    {
      $Output .= $Member['SubjectName'].': ';
      $Period = $this->GetBillingPeriod($Member['BillingPeriodNext']);
      if($Period['From'] > $Member['UNIX_TIMESTAMP(Member.BillingPeriodLastDate)'])
      {
        $this->Database->update('Member', 'Id='.$Member['Id'],
          array('BillingPeriod' => $Member['BillingPeriodNext']));
        $Member['BillingPeriod'] = $Member['BillingPeriodNext'];
      }
      $Period = $this->GetBillingPeriod($Member['BillingPeriod']);
      if(($Period['MonthCount'] > 0) and ($Member['Blocked'] == 0) and
        ($Period['From'] > $Member['UNIX_TIMESTAMP(Member.BillingPeriodLastDate)']))
      {
        $InvoiceItems = array();
        $MonthlyTotal = 0;
        $DbResult2 = $this->Database->query('SELECT Service.*, FinanceVAT.Value AS VAT '.
          'FROM ServiceCustomerRel LEFT JOIN Service '.
          'ON Service.Id=ServiceCustomerRel.Service '.
          'LEFT JOIN FinanceVAT ON FinanceVAT.Id=Service.VAT '.
          'WHERE (ServiceCustomerRel.Customer='.
          $Member['Id'].') AND (ServiceCustomerRel.Action IS NULL) ');
        while($Service = $DbResult2->fetch_assoc())
        {
          $InvoiceItems[] = array('Description' => $Service['Name'], 'Price' => $Service['Price'],
            'Quantity' => $Period['MonthCount'], 'VAT' => $Service['VAT']);
          $MonthlyTotal += $Service['Price'];
        }
        if($Member['MonthlyPlus'] != 0)
        {
          $InvoiceItems[] = array('Description' => 'Spotřeba energie', 'Price' => -$Member['MonthlyPlus'],
            'Quantity' => $Period['MonthCount'], 'VAT' => 2);
          $MonthlyTotal -= $Member['MonthlyPlus'];
        }
        $PayPerPeriod = $MonthlyTotal * $Period['MonthCount'];  
        if($PayPerPeriod != 0)
        {
          $TimePeriodText = date('j.n.Y', $Period['From']).' - '.date('j.n.Y', $Period['To']);
          $Output .= $TimePeriodText.': '.$MonthlyTotal.' * '.$Period['MonthCount'].' = '.$PayPerPeriod.'<br />';
          $this->InsertInvoice($Member['Subject'], time(), time() + 3600 * 24 * INVOICE_DUE_DAYS, 
            $InvoiceItems, INVOICE_OUT_DOC_LINE, $Period['From'], $Period['To']);
    
          $Output .= $this->SendPaymentEmail($Member['Id']);
        } else $Output .= '<br />';
        $this->Database->update('Member', 'Id='.$Member['Id'], 
          array('BillingPeriodLastDate' => TimeToMysqlDateTime($Period['To'])));
      } else $Output .= '<br />';
    }  
    return($Output);
  }
  
  function TableUpdatePeriod($Table)
  {
    $DbResult = $this->Database->select($Table, '*', '`Action` IS NOT NULL');
    while($Service = $DbResult->fetch_array())
    {
      if($Service['Action'] == 'add')
      {
        unset($Service['Id']);
        unset($Serivce['ReplaceId']);
        unset($Serivce['Action']);
        $this->Database->insert($Table, $Service);
      } else
      if($Service['Action'] == 'modify')
      {
        unset($Service['Id']);
        unset($Service['Action']);
        $ReplaceId = $Service['ReplaceId'];
        unset($Service['ReplaceId']);
        $this->Database->update($Table, 'Id='.$ReplaceId, $Service);
      } else
      if($Service['Action'] == 'delete')
      {
        $this->Database->delete($Table, '`Id`='.$Service['ReplaceId']);
      }
    }
    $this->Database->delete($Table, '`Action` IS NOT NULL');
  }  
  
  function ProcessMonthlyPayment()
  {
    if(!$this->System->User->CheckPermission('Finance', 'Manage')) return('Nemáte oprávnění');
    $Output = '';

    $Finance = &$this->System->Modules['Finance'];
    $Finance->LoadMonthParameters(0);
    
    // Načti poslední měsíční přehled a nastavení
    $DbResult = $this->Database->select('FinanceMonthlyOverall', '*', '1 ORDER BY Date DESC LIMIT 1');
    $Overall = $DbResult->fetch_array();

    $Output -= 'Datum: '.date('j.n.Y').'<br />';
    
    $DateParts = explode('-', $Overall['Date']);
    $MonthLast = $DateParts[1];
    $MonthCurrent = date('m') + 0;

    $Output .= $Finance->RecalculateSegmentParameters();
    $Output .= $Finance->LoadTariffs();
    $Output .= $Finance->RecalculateMemberPayment();

    // Celkovy prehled
    $DbResult = $this->Database->query('SELECT SUM(Product.SellPrice) AS Price FROM StockItem '.
      'JOIN Product ON StockItem.Product = Product.Id WHERE (StockItem.TimeElimination IS NULL) AND (StockItem.Segment IS NOT NULL)');
    $Row = $DbResult->fetch_row();
    $TotalDeviceCost = $Row[0];
    $Output .= 'Celková cena zařízení: Zařízení('.$TotalDeviceCost;
    
    $DbResult = $this->Database->query('SELECT SUM(Price) FROM NetworkSegment');
    $Row = $DbResult->fetch_row();
    $TotalSegmentDeviceCost = $Row[0];
    $Output .= '), Segmenty('.$TotalSegmentDeviceCost;
    
    $DbResult = $this->Database->query('SELECT SUM(NetworkDevice) FROM MemberPayment');
    $Row = $DbResult->fetch_row();
    $TotalMemberDeviceCost = $Row[0];
    $Output .= '), Členové('.$TotalMemberDeviceCost.')<br />';
    
    $DbResult = $this->Database->query('SELECT SUM(Cash) FROM MemberPayment');
    $Row = $DbResult->fetch_row();
    $TotalMemberCash = $Row[0];
    $Output .= 'Stav pokladny: Členové('.$TotalMemberCash.')';   

    $DbResult = $this->Database->query('SELECT SUM(Product.Consumption) AS Consumption FROM StockItem '.
      'JOIN Product ON StockItem.Product = Product.Id WHERE (StockItem.TimeElimination IS NULL) AND (StockItem.Segment IS NOT NULL)');
    $Row = $DbResult->fetch_row();
    $TotalConsumption = $Row[0];
    $TotalConsumptionCost = $Finance->W2Kc($TotalConsumption);

    $SpravaCelkem = $Finance->Sprava * $Finance->SpravaUsers;
    $Output .= 'Kontrola placení (Zaplaceno-Sprava-Internet): '.$Finance->TotalPaid.'-'.$SpravaCelkem.'-'.$Finance->Internet.'='.($Finance->TotalPaid - $SpravaCelkem - $Finance->Internet).'<br />';

    // Zkontrolovat odečtení měsíčního poplatku
    $Output .= 'Kontrola odečtení poplatků: Poslední měsíc-'.$MonthLast.' Aktuální měsíc-'.$MonthCurrent.'<br />';
    if($MonthCurrent != $MonthLast)
    {
      $Output .= 'Odečítám měsíční poplatek...<br />';
      $Output .= $this->ProduceInvoices();    
      
      // Update finance charge
      $Output .= 'Měním aktuální parametry sítě...<br>';
      $this->TableUpdatePeriod('FinanceCharge');

      $Output .= 'Přidávám měsíční přehled...<br />';
      $DbResult = $this->Database->query('SELECT * FROM FinanceCharge WHERE Action IS NULL LIMIT 1');
      $Charge = $DbResult->fetch_assoc();
      $this->Database->insert('FinanceMonthlyOverall', array('Date' => 'NOW()', 
        'Money' => $Finance->Internet, 'kWh' => $Finance->kWh, 
        'Administration' => $Finance->Sprava, 'AdministrationTotal' => $SpravaCelkem, 
        'ConsumptionTotal' => $TotalConsumptionCost, 'TotalPaid' => $Finance->TotalPaid, 
        'BaseTariffPrice' => $Charge['BaseTariffPrice'], 
        'TopTariffPrice' => $Charge['TopTariffPrice'], 'MemberCount' => $Finance->InternetUsers));

      // Update services
      $Output .= 'Aktualizuji služby....<br>';
      $this->TableUpdatePeriod('Service');    
      // Update customer service selections
      $Output .= 'Aktualizuji výběr služeb zákazníků....<br>';
      $this->TableUpdatePeriod('ServiceCustomerRel');     
      
      $Finance->RecalculateMemberPayment();
      //CreateMonthlyOverallBill();
      //$Finance->RecalculateUsersFinance();

      // Restart traffic shaping
      //$this->Database->update('NetworkConfiguration', 'Id = 3', array('Changed' => 1));     
      //flush();
      //$this->GenerateBills();
    }
    return($Output);
  }
  
  function SendPaymentEmail($MemberId, $FileId = '')
  {
    global $Config;
    
    $DbResult = $this->Database->select('Member', '*', 'Id='.$MemberId);
    $Member = $DbResult->fetch_assoc();

    $DbResult = $this->Database->select('MemberPayment', '*', 'Member='.$MemberId);
    $MemberPayment = $DbResult->fetch_assoc();   

    $DbResult = $this->Database->select('Subject', 'Name', 'Id='.$Member['Subject']);
    $Subject = $DbResult->fetch_assoc();      
    
    $DbResult = $this->Database->select('User', '*', 'Id='.$Member['ResponsibleUser']);    
    $User = $DbResult->fetch_assoc();
    
    $DbResult = $this->Database->select('Subject', '*', '`Id`='.$Config['Finance']['MainSubjectId']);
    $MainSubject = $DbResult->fetch_assoc();  
    
    $DbResult = $this->Database->query('SELECT FinanceBankAccount.*, CONCAT(FinanceBankAccount.Number, "/", FinanceBank.Code) AS NumberFull FROM FinanceBankAccount '.
      'JOIN FinanceBank ON FinanceBank.Id=FinanceBankAccount.Bank '.
      'WHERE (FinanceBankAccount.`Subject`='.$Config['Finance']['MainSubjectId'].') AND (FinanceBankAccount.`Use`=1)');
    $MainSubjectAccount = $DbResult->fetch_assoc();
        
    if($User['Email'] != '')
    {
      $Title = 'Pravidelné vyúčtování služeb';
      $Content = 'Vyúčtovaní zákazníka <strong>'.$Subject['Name'].'</strong> zastoupeného uživatelem <strong>'.$User['Name'].'</strong> ke dni <strong>'.$this->System->HumanDate(time()).'</strong>.<br /><br />'."\n".
        'Váše aktuální služby: ';
      $DbResult = $this->Database->query('SELECT GROUP_CONCAT(Service.Name) AS Name FROM ServiceCustomerRel LEFT JOIN Service '.
        'ON Service.Id=ServiceCustomerRel.Service WHERE (ServiceCustomerRel.Customer='.$Member['Id'].') '.
        'AND ServiceCustomerRel.Action IS NULL');
      $Service = $DbResult->fetch_assoc();
      $Content .= '<strong>'.$Service['Name'].'</strong><br />'."\n".
        'Vaše platební období: <strong>'.$this->System->Modules['Finance']->BillingPeriods[$Member['BillingPeriod']]['Name'].'</strong><br />'."\n".
        'Pravidelná platba za období: <strong>'.$MemberPayment['MonthlyTotal'].' Kč</strong><br />'."\n".
        'Bankovní účet: <strong>'.$MainSubjectAccount['NumberFull'].'</strong><br/>'."\n".
        'Variabilní symbol: <strong>'.$Member['Subject'].'</strong><br/>'."\n".
        'Stav vašeho účtu: <strong>'.($MemberPayment['Cash'] - $MemberPayment['MonthlyTotal']).' Kč</strong><br /><br />'."\n";
      $Content .= 'Nové finanční operace:<br/>'.
        '<table style="margin-left: auto; margin-right: auto; border-style: solid; border-width: 1px; border-collapse: collapse;"><tr><th style="border-style: solid; border-width: 1px; padding: 1px 5px 1px 5px; text-align: center; font-weight: bold;">Čas</th><th style="border-style: solid; border-width: 1px; padding: 1px 5px 1px 5px; text-align: center;; font-weight: bold;">Popis</th><th style="border-style: solid; border-width: 1px; padding: 1px 5px 1px 5px; text-align: center;; font-weight: bold;">Částka [Kč]</th></tr>'."\n";
      $DbResult = $this->Database->query('SELECT T1.* FROM ((SELECT Text, Time, Value AS Value, File FROM FinanceOperation WHERE (Subject='.$Member['Subject'].')) UNION ALL '.
      '(SELECT Text, TimeCreation as Time, -Value as Value, File FROM FinanceInvoice WHERE (Subject='.$Member['Subject'].')) ORDER BY Time DESC) AS T1 WHERE (T1.Time > "'.$Member['BillingPeriodLastDate'].'")');
      while($DbRow = $DbResult->fetch_assoc())
      {
        $Content .= '<tr><td style="border-style: solid; border-width: 1px; padding: 1px 5px 1px 5px; text-align: center;">'.HumanDate($DbRow['Time']).'</td>'.
          '<td style="border-style: solid; border-width: 1px; padding: 1px 5px 1px 5px; text-align: center;">'.$DbRow['Text'].'</td>'.
          '<td style="border-style: solid; border-width: 1px; padding: 1px 5px 1px 5px; text-align: center;">'.$DbRow['Value'].'</td></tr>'."\n";
      }
      $Content .= '</table><br />'."\n".
      'Pro aktuální informace, prohlížení elektronických dokladů a možnost změny údajů se prosím přihlašte na stránkách <a href="http://'.$Config['Web']['Host'].$Config['Web']['RootFolder'].'">http://'.$Config['Web']['Host'].$Config['Web']['RootFolder'].'</a>.<br /><br />'."\n";
        
      $Content .= '<br />Tento email je generován automaticky. V případě zjištění nesrovnalostí napište zpět.';
      $this->System->EmailQueue->AddItem($User['Name'].' <'.$User['Email'].'>', $Title, $Content, 
         $Config['Web']['Admin'].' <'.$Config['Web']['AdminEmail'].'>');
      $Output = '';
    } else $Output = 'Uživatel '.$User['Name'].' nemá email.';
  }
  
  function GenerateBills()
  {
    $Output = '';
    
    // FinanceInvoice
    $DbResult = $this->Database->query('SELECT * FROM `FinanceInvoice` WHERE (`BillCode` <> "") '.
      'AND (`Value` != 0) AND (`File` IS NULL)');
    while($Row = $DbResult->fetch_assoc())
    {
      $DbResult2 = $this->Database->insert('File', array('Name' => '', 'Size' => 0,
        'Directory' => $this->System->Modules['Finance']->DirectoryId, 'Time' => 'NOW()'));
      $FileId = $this->Database->insert_id;
      $FileName = 'doklad-'.$FileId.'.pdf';
      $Bill = new BillInvoice($this->System);
      $Bill->Database = &$this->System->Database;
      $Bill->System = &$this->System;
      $Bill->InvoiceId = $Row['Id'];
      $FullFileName = $this->System->Modules['File']->GetDir($this->System->Modules['Finance']->DirectoryId).$FileName;
      $Bill->SaveToFile($FullFileName);
      if(file_exists($FullFileName))
      {
        $this->Database->update('File', 'Id='.$FileId, array('Name' => $FileName, 'Size' => filesize($FullFileName)));
        $this->Database->update('FinanceInvoice', 'Id='.$Row['Id'], array('File' => $FileId));
        $Output .= '.';
      } else $Output .= 'Soubor "'.$FullFileName.'" se nepodařilo uložit.';
    }

    // FinanceOperations
    return($Output);
  }
}
