<?php
 
include('FioAPI.php');
 
class ImportFio extends FileImport
{
  function Import()
  {
    $DbResult = $this->Database->select('FinanceBankAccount', '*', 'Id='.$this->BankAccountId);    
    $BankAccount = $DbResult->fetch_assoc();
    
    $Fio = new FioAPI();
    $Fio->Token = $BankAccount['LoginName'];
    $Records = $Fio->Import(time() - 3600 * 24 * 31 * 2, time());
    foreach($Records as $Record)
    {
      echo('<tr>');
      if($Record['Type'] == GPC_TYPE_REPORT)
      {
        echo('<td>Jméno účtu: '.$Record['AccountName'].'</td>');
        echo('<td>Číslo účtu: '.$Record['AccountNumber'].'</td>');
        echo('<td>Ke dni '.date('j.n.Y', $Record['OldBalanceDate']).' je stav účtu '.$Record['OldBalanceValue'].' Kč</td>');
        echo('<td>Ke dni '.date('j.n.Y', $Record['Date']).' je stav účtu '.$Record['NewBalanceValue'].' Kč</td>');
        echo('<td>Suma příjmů: '.$Record['CreditValue'].' Kč</td>');
        echo('<td>Suma výdajů: '.$Record['DebitValue'].' Kč</td>');     
      } else
      if($Record['Type'] == GPC_TYPE_ITEM)
      {
        $this->Database->insert('FinanceBankImport', array('Time' => TimeToMysqlDate($Record['DueDate']),
          'BankAccount' => $this->BankAccount, 'Value' => $Record['Value'], 
          'SpecificSymbol' => $Record['SpecificSymbol'], 'VariableSymbol' => $Record['VariableSymbol'],
          'ConstantSymbol' => $Record['ConstantSymbol'], 'Currency' => $this->Currency,
          ));
        echo('<td>'.$Record['OffsetAccount'].'</td>');
        echo('<td>'.$Record['BankCode'].'</td>');
        echo('<td>'.$Record['ClientName'].'</td>');
      }
    }
  }
}
