<?php

class ModuleNetworkConfig extends AppModule
{
  function __construct($System)
  {
    parent::__construct($System);
    $this->Name = 'NetworkConfig';
    $this->Version = '1.0';
    $this->Creator = 'Chronos';
    $this->License = 'GNU/GPL';
    $this->Description = 'Network device remote configuration';
    $this->Dependencies = array('Network');
  }
  
  function Install()
  {
    parent::Install();
  }
  
  function UnInstall()
  {
    parent::UnInstall();
  }

  function Start()
  {
    parent::Start();
    $this->System->FormManager->RegisterClass('NetworkConfiguration', array(
      'Title' => 'Restart sítových služeb',
      'Table' => 'NetworkConfiguration',
      'Items' => array(
        'Caption' => array('Type' => 'String', 'Caption' => 'Jméno', 'Default' => ''),
        'Execute' => array('Type' => 'String', 'Caption' => 'Povely', 'Default' => ''),
        'Changed' => array('Type' => 'TNetworkConfigurationState', 'Caption' => 'Stav', 'Default' => 0),
        'LastTime' => array('Type' => 'DateTime', 'Caption' => 'Naposledy spuštěno', 'ReadOnly' => true),
        'ExecutionTime' => array('Type' => 'Integer', 'Caption' => 'Doba běhu', 'Default' => '0', 'Suffix' => 'sekund', 'ReadOnly' => true),
        'Enabled' => array('Type' => 'Boolean', 'Caption' => 'Povoleno', 'Default' => '0'),
        'Period' => array('Type' => 'Integer', 'Caption' => 'Min. perioda', 'Default' => '60', 'Suffix' => 'sekund'),
      ),
      'ItemActions' => array(
        array('Caption' => 'Záznam', 'URL' => '/is/?a=view&t=NetworkConfigurationLog'),
      ),
    ));
    $this->System->FormManager->RegisterClass('NetworkConfigurationLog', array(
      'Title' => 'Záznam restartu sítových služeb',
      'Table' => 'NetworkConfiguration',
      'Items' => array(
        'Caption' => array('Type' => 'String', 'Caption' => 'Jméno', 'Default' => ''),
        'Log' => array('Type' => 'Text', 'Caption' => 'Záznam', 'Default' => '', 'ReadOnly' => true),
      ),
    ));
    
  }
}
