<?php

class PageModules extends Page
{ 
  function __construct($System)
  {
    parent::__construct($System);
    $this->FullTitle = 'Správa modulů';
    $this->ShortTitle = 'Moduly';
    $this->ParentClass = 'PagePortal';
  }
  
  function ShowList()
  {
    $Output = '';
    $DbResult = $this->Database->query('SELECT COUNT(*) FROM `SystemModule`');
    $DbRow = $DbResult->fetch_row();
    $PageList = GetPageList($DbRow[0]);
    
    $Output .= $PageList['Output'];
    $Output .= '<table class="WideTable" style="font-size: small;">';
     
    $TableColumns = array(
        array('Name' => 'Name', 'Title' => 'Jméno'),
        array('Name' => 'Creator', 'Title' => 'Tvůrce'),
        array('Name' => 'Version', 'Title' => 'Verze'),
        array('Name' => 'License', 'Title' => 'Licence'),
        array('Name' => 'Installed', 'Title' => 'Instalováno'),
        array('Name' => 'Description', 'Title' => 'Popis'),
        array('Name' => 'Dependencies', 'Title' => 'Závislosti'),
        array('Name' => '', 'Title' => 'Akce'),
    );
    $Order = GetOrderTableHeader($TableColumns, 'Name', 0);
    $Output .= $Order['Output'];
    $Query = 'SELECT *, (SELECT GROUP_CONCAT(`T1`.`Name` SEPARATOR ", ") FROM `SystemModuleDependency` '.
        'LEFT JOIN `SystemModule` AS `T1` ON `T1`.`Id` = `SystemModuleDependency`.`DependencyModule` '.
        'WHERE `SystemModuleDependency`.`Module` = `SystemModule`.`Id`) AS `Dependencies` '.
        'FROM `SystemModule` '.$Order['SQL'].$PageList['SQLLimit'];
    
    $DbResult = $this->Database->query($Query);
    while($Module = $DbResult->fetch_assoc())
    {
      if($Module['Dependencies'] != '') $Dependencies = $Module['Dependencies'];
      else $Dependencies = '&nbsp;';
      if($Module['Installed'] == 1) $Installed = 'Ano';
      else $Installed = 'Ne';
      if($Module['Installed'] == 1) $Actions = '<a href="?A=Uninstall&amp;Id='.$Module['Id'].'">Odinstalovat</a>';
      else $Actions = '<a href="?A=Install&amp;Id='.$Module['Id'].'">Instalovat</a>';
      $Output .= '<tr><td>'.$Module['Name'].'</td>'.
          '<td>'.$Module['Creator'].'</td>'.
          '<td>'.$Module['Version'].'</td>'.
          '<td>'.$Module['License'].'</td>'.
          '<td>'.$Installed.'</td>'.
          '<td>'.$Module['Description'].'</td>'.
          '<td>'.$Dependencies.'</td>'.
          '<td>'.$Actions.'</td></tr>';
    }
    $Output .= '</table>';
    $Output .= $PageList['Output'];
    $Output .= '<p><a href="?A=SaveToDb">Uložit do databáze</a></p>';
    return($Output);    
  }
  
  function Show()
  {   
    $Output = '';
    if(array_key_exists('A', $_GET))
    {
      if($_GET['A'] == 'SaveToDb') 
      {
        $this->System->ModuleManager->Modules['System']->SaveToDatabase();
        $Output .= $this->SystemMessage('Načtení modulů', 'Seznam modulů v databázi zaktualizován');    
      } else
      if($_GET['A'] == 'Install') 
      {
        $this->System->ModuleManager->LoadModules(false);
        $ModuleName = $this->System->ModuleManager->SearchModuleById($_GET['Id']);
        if($ModuleName != '') 
        {
          $this->System->Modules[$ModuleName]->Install();
          $this->System->ModuleManager->Init();
        } else $Output .= 'Modul id '.$_GET['Id'].' nenalezen';
        
      } else
      if($_GET['A'] == 'Uninstall') 
      {
        $ModuleName = $this->System->ModuleManager->SearchModuleById($_GET['Id']);
        if($ModuleName != '') 
        {
          $this->System->ModuleManager->Modules[$ModuleName]->UnInstall();
          $this->System->ModuleManager->Init();
        } else $Output .= 'Modul id '.$_GET['Id'].' nenalezen';
      } else $Output .= 'Neplatná akce';         
    }
    $Output .= $this->ShowList();
    return($Output);    
  }
}
  

class ModuleSystem extends AppModule
{
  var $InstalledChecked;
        
  function __construct($System)
  {
    parent::__construct($System);
    $this->Name = 'System';
    $this->Version = '1.0';
    $this->Creator = 'Chronos';
    $this->License = 'GNU/GPL';
    $this->Description = 'Base system module';
    $this->Dependencies = array();
  }
  
  function Install()
  {
    if($this->IsInstalled()) return;
    parent::Install();
    $this->Database->query('CREATE TABLE IF NOT EXISTS `SystemVersion` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Version` varchar(255) COLLATE utf8_czech_ci NOT NULL,
  `Description` datetime NOT NULL,
  PRIMARY KEY (`Id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_czech_ci AUTO_INCREMENT=1;');
    $this->Database->query('CREATE TABLE IF NOT EXISTS `SystemModule` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Name` varchar(255) COLLATE utf8_czech_ci NOT NULL,
  `Creator` varchar(255) COLLATE utf8_czech_ci NOT NULL,
  `Version` varchar(255) COLLATE utf8_czech_ci NOT NULL,
  `License` varchar(255) COLLATE utf8_czech_ci NOT NULL,
  `Installed` int(11) NOT NULL,
  `Description` text COLLATE utf8_czech_ci NOT NULL,
  PRIMARY KEY (`Id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_czech_ci AUTO_INCREMENT=1;');
    
    $this->Database->query('CREATE TABLE IF NOT EXISTS `SystemModuleDependency` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Module` int(11) NOT NULL,
  `DependencyModule` int(11) NOT NULL,
  PRIMARY KEY (`Id`),
  KEY (`Module`),
  KEY (`DependencyModule`),
  UNIQUE (`Module` , `DependencyModule`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_czech_ci AUTO_INCREMENT=1;');
    $this->Database->query('ALTER TABLE `SystemModuleDependency` ADD CONSTRAINT `SystemModuleDependency_ibfk_1` FOREIGN KEY ( `Module` ) REFERENCES `SystemModule` (`Id`)');
    $this->Database->query('ALTER TABLE `SystemModuleDependency` ADD CONSTRAINT `SystemModuleDependency_ibfk_2` FOREIGN KEY ( `DependencyModule` ) REFERENCES `SystemModule` (`Id`)');
    
    $this->Database->query('CREATE TABLE IF NOT EXISTS `SystemModel` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Name` varchar(255) COLLATE utf8_czech_ci NOT NULL,
  `Module` int(11) NOT NULL,
  KEY (`Module`),
  PRIMARY KEY (`Id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_czech_ci AUTO_INCREMENT=1;');
    $this->Database->query('ALTER TABLE `SystemModel` ADD CONSTRAINT `SystemModel_ibfk_1` FOREIGN KEY ( `Module` ) REFERENCES `SystemModule` (`Id`)');
    
    $this->Database->query('CREATE TABLE IF NOT EXISTS `SystemModelProperty` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Name` varchar(255) COLLATE utf8_czech_ci NOT NULL,
  `Type` varchar(255) COLLATE utf8_czech_ci NOT NULL,
  `Model` int(11) NOT NULL,
  KEY (`Model`),
  PRIMARY KEY (`Id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_czech_ci AUTO_INCREMENT=1;');
    $this->Database->query('ALTER TABLE `SystemModelProperty` ADD CONSTRAINT `SystemModelProperty_ibfk_1` FOREIGN KEY ( `Model` ) REFERENCES `SystemModel` (`Id`)');
  }
  
  function UnInstall()
  {
    parent::UnInstall();
    if(!$this->IsInstalled()) return;
    
    // Delete tables with reverse order
    $this->Database->query('ALTER TABLE `SystemModelProperty` DROP FOREIGN KEY `SystemModelProperty_ibfk_1`');
    $this->Database->query('DROP TABLE IF EXISTS `SystemModelProperty`');
    $this->Database->query('ALTER TABLE `SystemModel` DROP FOREIGN KEY `SystemModel_ibfk_1`');
    $this->Database->query('DROP TABLE IF EXISTS `SystemModel`');
    $this->Database->query('ALTER TABLE `SystemModuleDependency` DROP FOREIGN KEY `SystemModuleDependency_ibfk_1`');
    $this->Database->query('ALTER TABLE `SystemModuleDependency` DROP FOREIGN KEY `SystemModuleDependency_ibfk_2`');
    $this->Database->query('DROP TABLE IF EXISTS `SystemModuleDependency`');
    $this->Database->query('DROP TABLE IF EXISTS `SystemModule`');
    $this->Database->query('DROP TABLE IF EXISTS `SystemVersion`');
  }

  function Start()
  {
    parent::Start();
    $this->System->RegisterPage('module', 'PageModules');
    //$this->Manager->OnModuleChange = array($this, 'ModuleChange');
    //$this->LoadFromDatabase();
  }
  
  function Stop()
  {
    parent::Stop();
  }
  
  function IsInstalled()
  {
    if($this->InstalledChecked == false)
    {
      $DbResult = $this->Database->query('SELECT table_name FROM information_schema.tables
WHERE table_schema = "'.$this->Database->Database.'" AND table_name = "SystemVersion";');    
      if($DbResult->num_rows > 0) $this->Installed = true;
        else $this->Installed = false;
      $this->InstalledChecked = true;
    }
    return($this->Installed); 
  }
  
  function ModuleChange($Module)
  {
    //if($this->IsInstalled())
    {
       
      if($Module->IsInstalled()) $Installed = 1;
        else $Installed = 0; 
      $this->Database->query('UPDATE `SystemModule` SET `Installed`=1 WHERE `Name`="'.$Module->Name.'"');
    }
  }
  
  function LoadFromDatabase()
  {
    //DebugLog('Loading modules...');
    $this->Modules = array();
    $Query = 'SELECT `Id`, `Name`,`Installed` FROM `SystemModule`';
    $DbResult = $this->Database->query($Query);
    while($Module = $DbResult->fetch_array())
    {
      //echo($Module['Name'].',');
      include_once('Modules/'.$Module['Name'].'/'.$Module['Name'].'.php');
      $ModuleClassName = 'Module'.$Module['Name'];
      $NewModule = new $ModuleClassName($this->Database, $this->Manager);      
      $NewModule->Id = $Module['Id'];
      $NewModule->Installed = $Module['Installed'];      
      $this->Manager->RegisterModule($NewModule);
    }     
  }
 
  function SaveToDatabase()
  {
    $Modules = array();
    $DbResult = $this->Database->query('SELECT * FROM `SystemModule`');
    while($DbRow = $DbResult->fetch_assoc())
    {
      $Modules[$DbRow['Name']] = $DbRow;
      if($this->System->ModuleManager->ModulePresent($DbRow['Name']))
        $this->System->ModuleManager->Modules[$DbRow['Name']]->Id = $DbRow['Id'];
    }

    // Add missing
    foreach($this->System->ModuleManager->Modules as $Module)    
    {      
      if(!array_key_exists($Module->Name, $Modules))
      {
        $this->Database->insert('SystemModule', array('Name' => $Module->Name, 
          'Version' => $Module->Version, 'Creator' => $Module->Creator, 
          'Description' => $Module->Description, 'License' => $Module->License,
          'Installed' => $Module->Installed));
        $this->System->ModuleManager->Modules[$Module->Name]->Id = $this->Database->insert_id;
      }
      else $this->Database->update('SystemModule', 'Name = "'.$Module->Name.'"', array(
        'Version' => $Module->Version, 'Creator' => $Module->Creator, 
        'Description' => $Module->Description, 'License' => $Module->License,
        'Installed' => $Module->Installed));
    }
    
    // Remove exceeding
    foreach($Modules as $Module)    
    if(!$this->System->ModuleManager->ModulePresent($Module['Name']))
    {
      DebugLog('Removing module '.$Module['Name'].' from list');
      $this->Database->query('DELETE FROM `SystemModule` WHERE `Id` = '.$Module['Id']);
    }   
    
    // Reload dependencies
    $DbDependency = array();
    $DbResult = $this->Database->query('SELECT * FROM `SystemModuleDependency`');
    while($DbRow = $DbResult->fetch_assoc())
      $DbDependency[$DbRow['Module']][] = $DbRow['DependencyModule'];
    
    foreach($this->System->ModuleManager->Modules as $Module)
    {
      // Add missing
      foreach($Module->Dependencies as $Dependency)
      {
        if(!array_key_exists($Module->Id, $DbDependency) or
        !in_array($this->System->ModuleManager->Modules[$Dependency]->Id, $DbDependency[$Module->Id]))
        {
          if(array_key_exists($Dependency, $this->System->ModuleManager->Modules))
            $DependencyId = $this->System->ModuleManager->Modules[$Dependency]->Id;
            else throw new Exception('Dependent module '.$Dependency.' not found');
          $this->Database->insert('SystemModuleDependency', array('Module' => $Module->Id, 
            'DependencyModule' => $DependencyId));
        }        
      }
      
      // Remove exceeding
      if(array_key_exists($Module->Id, $DbDependency))
      foreach($DbDependency[$Module->Id] as $Dep)
      {
        $DepModName = $this->System->ModuleManager->SearchModuleById($Dep);
        if(!in_array($DepModName, $Module->Dependencies))
        $this->Database->query('DELETE FROM `SystemModuleDependency` WHERE `Module` = '.
          $Module->Id.' AND DependencyModule='.$Dep);
      }      
    }
  } 
}
