<?php

function UpdateTo493($Manager)
{      
  $Manager->Execute("ALTER TABLE `UserOnline` CHANGE `User` `User` INT( 11 ) NULL DEFAULT NULL COMMENT 'User.Id'");
}

function UpdateTo494($Manager)
{      
  $Manager->Execute("ALTER TABLE `FinanceOperation` DROP FOREIGN KEY `FinanceOperation_ibfk_2` ;\n".
    "ALTER TABLE `FinanceOperation` CHANGE `Bill` `File` INT( 11 ) NULL DEFAULT NULL;\n".
    "ALTER TABLE `FinanceOperation` ADD FOREIGN KEY ( `File` ) REFERENCES `File` (`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
}

function UpdateTo495($Manager)
{
  $Manager->Execute("INSERT INTO `MapPosition` (SELECT NULL AS `Id`, `Name`, `MapPositionX` AS `Latitude`, `MapPositionY` AS `Longitude` FROM `Subject`)");
  $Manager->Execute("ALTER TABLE `Subject` ADD `MapPosition` INT NULL AFTER `PayVAT`");
  $Manager->Execute("UPDATE `Subject` SET `MapPosition` = (SELECT `MapPosition`.`Id` FROM `MapPosition` WHERE `MapPosition`.`Name` = `Subject`.`Name` LIMIT 1)");
  $Manager->Execute("ALTER TABLE `Subject`  DROP `MapPositionX`,  DROP `MapPositionY`;");
  $Manager->Execute("ALTER TABLE `Subject` ADD INDEX ( `MapPosition` ) ");
  $Manager->Execute("ALTER TABLE `Subject` ADD FOREIGN KEY ( `MapPosition` ) REFERENCES `MapPosition` (".
    "`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
}

function UpdateTo497($Manager)
{
  $Manager->Execute("ALTER TABLE `FinanceCharge` ADD `Id` INT NOT NULL AUTO_INCREMENT FIRST , ADD PRIMARY KEY ( `Id` ) ");
  $Manager->Execute("ALTER TABLE `FinanceCharge` ADD `ReplaceId` INT NULL ,ADD INDEX ( `ReplaceId` ) ");
  $Manager->Execute("DELETE FROM `FinanceCharge` WHERE `FinanceCharge`.`Period` = 1");
  $Manager->Execute("ALTER TABLE `FinanceCharge` DROP `Period`");
  $Manager->Execute("ALTER TABLE `FinanceCharge` ADD `Action` ENUM( 'add', 'modify', 'remove' ) NULL AFTER `TopTariffPrice` ");
  $Manager->Execute("ALTER TABLE `FinanceCharge` ADD FOREIGN KEY ( `ReplaceId` ) REFERENCES `FinanceCharge` (".
    "`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
  $Manager->Execute("ALTER TABLE `FinanceCharge` ADD INDEX ( `Action` )");
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
    "VALUES (NULL , 'Parametry účtování', '2', 'FinanceCharge', '');");
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
    "VALUES (NULL , 'Úseky sítě', '2', 'NetworkSegment', '');");
  $Manager->Execute("ALTER TABLE `ServiceCustomerRel` ADD `Action` ENUM( 'add', 'modify', 'remove' ) NULL , ".
    "ADD `ReplaceId` INT NULL");
  $Manager->Execute("DELETE FROM `ServiceCustomerRel` WHERE `Period`=1");
  $Manager->Execute("ALTER TABLE `ServiceCustomerRel` DROP `Period`");
  $Manager->Execute("ALTER TABLE `ServiceCustomerRel` ADD INDEX ( `Action` )");
  $Manager->Execute("ALTER TABLE `ServiceCustomerRel` ADD INDEX ( `ReplaceId` ) ");
  $Manager->Execute("ALTER TABLE `ServiceCustomerRel` ADD FOREIGN KEY ( `ReplaceId` ) REFERENCES `ServiceCustomerRel` (".
    "`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
  $Manager->Execute("ALTER TABLE `Service` ADD `Action` ENUM( 'add', 'modify', 'remove' ) NULL AFTER `CustomerCount`");
  $Manager->Execute("ALTER TABLE `Service` ADD INDEX ( `Action` )");
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
    "VALUES (NULL , 'Placení zákazníků', '2', 'MemberPayment', '');");
}

function UpdateTo498($Manager)
{
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
    "VALUES (NULL , 'Sítové služby', '1', 'NetworkConfiguration', '');");
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
    "VALUES (NULL , 'Fronta e-mailů', '23', 'EmailQueue', '');");
  $Manager->Execute("CREATE TABLE IF NOT EXISTS `FinanceVAT` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Name` varchar(255) NOT NULL,
  `ValidFrom` date NOT NULL,
  `Value` int(11) NOT NULL,
  PRIMARY KEY (`Id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
INSERT INTO `FinanceVAT` (`Id`, `Name`, `ValidFrom`, `Value`) VALUES
(1, 'DPH snížená sazba', '2013-01-01', 15),
(2, 'DPH běžná sazba', '2013-01-01', 21);");
  $Manager->Execute("ALTER TABLE `Service` ADD `VAT` INT NOT NULL AFTER `Price`");
  $Manager->Execute("ALTER TABLE `Service` ADD INDEX ( `VAT` ) ");
  $Manager->Execute("UPDATE `Service` SET `VAT` = 2;");
  $Manager->Execute("ALTER TABLE `Service` ADD FOREIGN KEY ( `VAT` ) REFERENCES `FinanceVAT` (".
    "`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
  $Manager->Execute("ALTER TABLE `FinanceInvoice` ADD `Cash` INT NOT NULL DEFAULT '0'");
}

function UpdateTo499($Manager)
{
  $Manager->Execute("CREATE TABLE IF NOT EXISTS `Currency` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Code` varchar(3) NOT NULL,
  `Name` varchar(255) NOT NULL,
  `Symbol` varchar(255) NOT NULL,
  PRIMARY KEY (`Id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=5 ;

INSERT INTO `Currency` (`Id`, `Code`, `Name`, `Symbol`) VALUES
(1, 'CZK', 'Česká koruna', 'Kč'),
(2, 'EUR', 'Euro', '€'),
(3, 'USD', 'Americký dolar', '$'),
(4, 'CNY', 'Čínský jüan', '¥');");
  $Manager->Execute("CREATE TABLE IF NOT EXISTS `FinanceBankImport` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `BankAccount` int(11) NOT NULL,
  `Time` date NOT NULL,
  `Identification` varchar(255) NOT NULL,
  `AccountNumber` varchar(255) NOT NULL,
  `VariableSymbol` varchar(255) NOT NULL,
  `ConstantSymbol` varchar(255) NOT NULL,
  `SpecificSymbol` varchar(255) NOT NULL,
  `Value` decimal(10,0) NOT NULL,
  `Currency` int(11) NOT NULL,
  `Description` varchar(255) NOT NULL,
  `OffsetAccountName` varchar(255) NOT NULL,
  `FinanceOperation` int(11) DEFAULT NULL,
  PRIMARY KEY (`Id`),
  KEY `FinanceOperation` (`FinanceOperation`),
  KEY `Currency` (`Currency`),
  KEY `BankAccount` (`BankAccount`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

ALTER TABLE `FinanceBankImport`
  ADD CONSTRAINT `FinanceBankImport_ibfk_3` FOREIGN KEY (`FinanceOperation`) REFERENCES `FinanceOperation` (`Id`),
  ADD CONSTRAINT `FinanceBankImport_ibfk_1` FOREIGN KEY (`BankAccount`) REFERENCES `FinanceBankAccount` (`Id`),
  ADD CONSTRAINT `FinanceBankImport_ibfk_2` FOREIGN KEY (`Currency`) REFERENCES `Currency` (`Id`);");
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`)".
  "VALUES (NULL , 'Měny', '2', 'Currency', '');");
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
    "VALUES (NULL , 'Import z účtu', '2', 'FinanceBankImport', '');");
}

function UpdateTo500($Manager)
{
  $Manager->Execute("CREATE TABLE IF NOT EXISTS `FinanceBank` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Name` varchar(255) NOT NULL,
  `Code` varchar(4) NOT NULL,
  `BIC` varchar(255) NOT NULL,
  `Country` int(11) NOT NULL,
  PRIMARY KEY (`Id`),
  KEY `Country` (`Country`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;");
  $Manager->Execute("ALTER TABLE `FinanceBank`
  ADD CONSTRAINT `FinanceBank_ibfk_1` FOREIGN KEY (`Country`) REFERENCES `Country` (`Id`);");
  $Manager->Execute("ALTER TABLE `FinanceBankAccount` ADD `Bank` INT NOT NULL AFTER `Number` ,".
     " ADD INDEX ( `Bank` )");
  $Manager->Execute("INSERT INTO `FinanceBank` (`Id`, `Name`, `Code`, `BIC`, `Country`) VALUES
  (1, 'Neznámá banka', '', '', 1);");
  $Manager->Execute("UPDATE `FinanceBankAccount` SET `Bank` = 1 WHERE `Bank` = 0");
  $Manager->Execute("ALTER TABLE `FinanceBankAccount` ADD FOREIGN KEY ( `Bank` ) REFERENCES `FinanceBank` (".
    "`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
    "VALUES (NULL , 'Banky', '2', 'FinanceBank', '');");
}

function UpdateTo502($Manager)
{
  $Manager->Execute("ALTER TABLE `FinanceBankAccount` ADD `LoginName` VARCHAR( 255 ) NOT NULL ");
  $Manager->Execute("ALTER TABLE `FinanceBankAccount` ADD `LoginPassword` VARCHAR( 255 ) NOT NULL");
  $Manager->Execute("ALTER TABLE `FinanceBankAccount` ADD `Currency` INT NOT NULL AFTER `Use` ,".
    "ADD INDEX ( `Currency` ) ");
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
    "VALUES (NULL , 'Banka', '2', '', '');");
  $Id = $Manager->Database->insert_id;
  $Manager->Execute("UPDATE `ISMenuItem` SET `Parent` = '".$Id."' WHERE `ISMenuItem`.`Id` ='Bankovní účty'; ".
    "UPDATE `ISMenuItem` SET `Parent` = '".$Id."' WHERE `ISMenuItem`.`Id` ='Import z účtu';".
    "UPDATE `ISMenuItem` SET `Parent` = '".$Id."' WHERE `ISMenuItem`.`Name` ='Banky';");
}

function UpdateTo505($Manager)
{
  $Manager->Execute("UPDATE `ISMenuItem` SET `Name` = 'Služby', `Table` = 'Service' WHERE `ISMenuItem`.`Name` ='Tarify';");
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
      "VALUES (NULL , 'Kategorie služeb', '2', 'ServiceCategory', '');");
  $Manager->Execute("CREATE TABLE IF NOT EXISTS `NetworkShareItem` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Name` varchar(255) NOT NULL DEFAULT '',
  `Parent` int(11) NOT NULL DEFAULT '0',
  `Host` int(11) NOT NULL DEFAULT '0',
  `Size` bigint(20) NOT NULL DEFAULT '0',
  `Ext` varchar(64) NOT NULL DEFAULT '',
  `Date` date NOT NULL DEFAULT '0000-00-00',
  `Type` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`Id`),
  KEY `Parent` (`Parent`),
  KEY `Search` (`Name`,`Size`),
  KEY `Name` (`Name`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;");
  $Manager->Execute("CREATE TABLE IF NOT EXISTS `NetworkShareError` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Host` varchar(16) NOT NULL DEFAULT '',
  `Message` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`Id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;"); 
}

function UpdateTo507($Manager)
{
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
    "VALUES (NULL , 'Aktuality', NULL, '', '');");
  $Id = $Manager->Database->insert_id;
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
    "VALUES (NULL , 'Aktuality', '".$Id."', 'News', '');");
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
    "VALUES (NULL , 'Kategorie aktualit', '".$Id."', 'NewsCategory', '');");
  $Manager->Execute("INSERT INTO `FileDirectory` (`Id` ,`Name` ,`Parent`".
    ") VALUES (NULL , 'news', NULL);");
  $Manager->Execute("ALTER TABLE `File` ADD `Time` DATETIME NOT NULL ");
  // Convert Hire column to Service item
  $Manager->Execute("INSERT INTO `ServiceCategory` (
`Id` ,`Name`) VALUES (NULL , 'Pevný nájem');");
  $ServiceCategoryHire = $Manager->Database->insert_id;  
  $DbResult = $Manager->Execute("SELECT * FROM Member WHERE Hire>0");
  while($Member = $DbResult->fetch_assoc())
  {
    $Manager->Execute("INSERT INTO `Service` (
`Id` ,`Name` ,`Category` ,`Price` ,`VAT` ,`CustomerCount` ,`Action` ,`ReplaceId` ,
`Public` ,`InternetSpeedMin` ,`InternetSpeedMax` ,`UploadAsymmetry` ,`Memory` ,`MemorySwap` ,`Storage` ,`CPUCount`)
VALUES (
NULL , 'Nájem', '".$ServiceCategoryHire."', '-".$Member['Hire']."', '2', '', NULL , NULL , '', '', '', '', '', '', '', ''
);");
    $ServiceHire = $Manager->Database->insert_id;  
    $Manager->Execute("INSERT INTO `ServiceCustomerRel` (`Service`, `Customer`) VALUES ". 
      "(".$ServiceHire.",".$Member['Id'].")");
  }
  $Manager->Execute("ALTER TABLE `Member` DROP `Hire`");
  // Each device and subnet have to be assigned to payed service to determine service parameters
  $Manager->Execute("ALTER TABLE `NetworkDevice` ADD `Service` INT NULL AFTER `Location` ,
ADD INDEX ( `Service` )");
  $Manager->Execute("ALTER TABLE `NetworkDevice` ADD FOREIGN KEY ( `Service` ) REFERENCES `ServiceCustomerRel` (
`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
  $Manager->Execute("UPDATE `NetworkDevice` SET `Service` = (SELECT `Id` FROM `ServiceCustomerRel` WHERE `ServiceCustomerRel`.`Customer` = `NetworkDevice`.`Member` LIMIT 1)");
  $Manager->Execute("ALTER TABLE `NetworkSubnet` ADD `Service` INT NULL AFTER `Member` ,
ADD INDEX ( `Service` ) ");
  $Manager->Execute("ALTER TABLE `NetworkSubnet` ADD FOREIGN KEY ( `Service` ) REFERENCES `ServiceCustomerRel` (
`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
  $Manager->Execute("UPDATE `NetworkSubnet` SET `Service` = (SELECT `Id` FROM `ServiceCustomerRel` WHERE `ServiceCustomerRel`.`Customer` = `NetworkSubnet`.`Member` LIMIT 1)"); 
}

function UpdateTo515($Manager)
{
  $Manager->Execute("ALTER TABLE `PermissionUserAssignment` CHANGE `User` `User` INT( 11 ) NULL");
}

function UpdateTo517($Manager)
{
  $Manager->Execute("ALTER TABLE `Log` ADD `IPAddress` VARCHAR( 16 ) NOT NULL");
}

function UpdateTo526($Manager)
{
  $Manager->Execute("ALTER TABLE `Hyperlink` CHANGE `Name` `Title` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_czech_ci NOT NULL");
  $Manager->Execute("ALTER TABLE `Hyperlink` ADD `Name` VARCHAR( 255 ) NOT NULL AFTER `Id`");
  //$Manager->Execute("ALTER TABLE `Hyperlink` ADD UNIQUE ( `Name` )");
  $Manager->Execute("ALTER TABLE `Hyperlink` ADD `Type` INT NOT NULL AFTER `Title` , ADD INDEX ( `Type` )");
  $Manager->Execute("RENAME TABLE `Hyperlink` TO `Action` ;");
  $Manager->Execute("RENAME TABLE `HyperlinkGroup` TO `ActionGroup` ;");
  $Manager->Execute("CREATE TABLE IF NOT EXISTS `ActionType` (
      `Id` int(11) NOT NULL AUTO_INCREMENT,
      `Name` varchar(255) NOT NULL,
      PRIMARY KEY (`Id`)
  ) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3 ;
  
  INSERT INTO `ActionType` (`Id`, `Name`) VALUES
  (1, 'Odkaz'),
  (2, 'Obrázek');");
  $Manager->Execute("UPDATE `Action` SET `Type` = 1;");
  $Manager->Execute("ALTER TABLE `Action` ADD FOREIGN KEY ( `Type` ) REFERENCES `ActionType` (".
    "`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
  $Manager->Execute("UPDATE `Panel` SET `Module` = 'ActionGroup' WHERE `Module` = 'HyperlinkGroup'");
  $Manager->Execute("CREATE TABLE IF NOT EXISTS `ActionIcon` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Name` varchar(255) NOT NULL,
  PRIMARY KEY (`Id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;");
  $Manager->Execute("INSERT INTO `ActionIcon` (SELECT NULL AS `Id`, `IconFile` AS `Name` FROM `Action` WHERE `IconFile` != '' GROUP BY `IconFile`)");
  $Manager->Execute("ALTER TABLE `Action` CHANGE `IconFile` `IconFile` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL");
  $Manager->Execute("UPDATE `Action` SET `IconFile` = (SELECT `Id` FROM `ActionIcon` WHERE `ActionIcon`.`Name` = `Action`.`IconFile`) ");
  $Manager->Execute("ALTER TABLE `Action` CHANGE `IconFile` `Icon` INT NULL ");
  $Manager->Execute("UPDATE `Action` SET `Icon` = NULL WHERE `Icon` = 0");
  $Manager->Execute("ALTER TABLE `Action` ADD INDEX ( `Icon` ) ");
  $Manager->Execute("ALTER TABLE `Action` ADD FOREIGN KEY ( `Icon` ) REFERENCES `ActionIcon` (`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
  $Manager->Execute("INSERT INTO `ISMenuItem` (`Id` ,`Name` ,`Parent` ,`Table` ,`IconName`) ".
    "VALUES (NULL , 'Akce', '23', 'Action', '');");
}

function UpdateTo527($Manager)
{
  $Manager->Execute("RENAME TABLE `ISMenuItem` TO `MenuItem` ;");
  $Manager->Execute("CREATE TABLE IF NOT EXISTS `Menu` (
  `Id` int(11) NOT NULL AUTO_INCREMENT,
  `Name` varchar(255) NOT NULL,
  PRIMARY KEY (`Id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;");
  $Manager->Execute("INSERT INTO `Menu` (`Id` ,`Name`)VALUES (NULL , 'IS');");
  $Manager->Execute("ALTER TABLE `MenuItem` ADD `Menu` INT NOT NULL , ADD INDEX ( `Menu` )");
  $Manager->Execute("UPDATE `MenuItem` SET `Menu` = 1");
  $Manager->Execute("ALTER TABLE `MenuItem` ADD FOREIGN KEY ( `Menu` ) REFERENCES `Menu` (".
    "`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
  $Manager->Execute("ALTER TABLE `Action` CHANGE `Group` `Group` INT( 11 ) NULL ");
  $Manager->Execute("INSERT INTO `Action` (SELECT NULL AS `Id`, '' AS `Name`, `Name` AS `Title`, 1 AS `Type`, CONCAT('/is/?t=', `Table`, '&a=list') AS `URL`, NULL AS `Group`, NULL AS `Icon`, NULL AS `PermisionModule`,  NULL AS `PermissionOperation`, 1 AS `Enable` FROM `MenuItem` WHERE `Parent` IS NOT NULL)");
  $Manager->Execute("ALTER TABLE `MenuItem` DROP `IconName`");
  $Manager->Execute("UPDATE `MenuItem` SET `Table` = (SELECT `Id` FROM `Action` WHERE `Action`.`URL` = CONCAT('/is/?t=', `MenuItem`.`Table`, '&a=list')) WHERE `MenuItem`.`Table` != ''");
  $Manager->Execute("ALTER TABLE `MenuItem` CHANGE `Table` `Action` INT NULL");
  $Manager->Execute("UPDATE `MenuItem` SET `Action` = NULL WHERE `Action` = 0");
  $Manager->Execute("ALTER TABLE `MenuItem` ADD INDEX ( `Action` ) ");
  $Manager->Execute("ALTER TABLE `MenuItem` ADD FOREIGN KEY ( `Action` ) REFERENCES `Action` (`Id`) ON DELETE RESTRICT ON UPDATE RESTRICT ;");
  $Manager->Execute("INSERT INTO `Action` (`Id` ,`Name` ,`Title` ,`Type` ,`URL` ,`Group` ,`Icon` ,`PermissionModule` ,`PermissionOperation` ,`Enable`)".
    "VALUES (NULL , '', 'Nabídky', '1', '/is/?t=Menu&a=list', NULL , NULL , '', '', '1');");
  $ActionId = $Manager->Database->insert_id;
  $Manager->Execute("INSERT INTO `MenuItem` (`Id` ,`Name` ,`Parent` ,`Action` ,`Menu`) ".
    "VALUES (NULL , 'Nabídky', '23', '".$ActionId."', '1');");  
}

function UpdateTo535($Manager)
{
  // Set all string collation to utf8 general
  $DbResult = $Manager->Execute("SHOW TABLES");
  while($DbRow = $DbResult->fetch_row())
  {
    $Manager->Execute("ALTER TABLE `".$DbRow[0]."` CONVERT TO CHARACTER SET utf8"); 
  }  
}

$Updates = array(
  491 => array('Revision' => 493, 'Function' => 'UpdateTo493'),
  493 => array('Revision' => 494, 'Function' => 'UpdateTo494'),
  494 => array('Revision' => 495, 'Function' => 'UpdateTo495'),
  495 => array('Revision' => 497, 'Function' => 'UpdateTo497'),
  497 => array('Revision' => 498, 'Function' => 'UpdateTo498'),
  498 => array('Revision' => 499, 'Function' => 'UpdateTo499'),
  499 => array('Revision' => 500, 'Function' => 'UpdateTo500'),
  500 => array('Revision' => 502, 'Function' => 'UpdateTo502'),
  502 => array('Revision' => 505, 'Function' => 'UpdateTo505'),
  505 => array('Revision' => 507, 'Function' => 'UpdateTo507'),
  507 => array('Revision' => 515, 'Function' => 'UpdateTo515'),
  515 => array('Revision' => 517, 'Function' => 'UpdateTo517'),
  517 => array('Revision' => 526, 'Function' => 'UpdateTo526'),
  526 => array('Revision' => 527, 'Function' => 'UpdateTo527'),
  527 => array('Revision' => 535, 'Function' => 'UpdateTo535'),
);
