<?php

include('Image.php');

class MeteoStation 
{
  var $Id;
  var $Name;
  var $Period;
  var $URL;

  function LoadTestData()
  {
    $Data = array('MeteoStation' => $this->Id,
        'WindSpeed' => 1.4,
        'WindDir' => 3,
        'WindGust' => 1.5,
        'Pressure' => 979.8,
        'SysTemp' => 9.9,
        'Temperature' => 1.4,
        'BarAltitude' => 581.0,
        'WindChill' => 1.4,
        'RelHumidity' => 92.6,
        'AbsHumidity' => 4.6,
        'DewPoint' => 0.4,
        'Time' => time(),
    );
    $this->Data = $Data;
  }
  
  function DownloadData()
  {
    $XmlData = simplexml_load_file($this->URL);

    $Data = array('MeteoStation' => $this->Id, 
      'WindSpeed' => trim($XmlData->windspeed),
      'WindDir' => trim($XmlData->winddir),
      'WindGust' => trim($XmlData->windgust),
      'Pressure' => trim($XmlData->pressure),
      'SysTemp' => trim($XmlData->systemp),
      'Temperature' => trim($XmlData->temperature),
      'BarAltitude' => trim($XmlData->baraltitude),
      'WindChill' => trim($XmlData->windchill),
      'RelHumidity' => trim($XmlData->relhumidity),
      'AbsHumidity' => trim($XmlData->abshumidity),
      'DewPoint' => trim($XmlData->dewpoint),
      'Time' => time(),
    );
    $this->Data = $Data;
  }
  
  function SaveDataToDb()
  {
    $this->Database->insert('MeteoStationMeasure', array(
      'Time' => TimeToMysqlDateTime(time()), 'MeteoStation' => $this->Data['MeteoStation'],
      'WindSpeed' => $this->Data['WindSpeed'], 'WindDir' => $this->Data['WindDir'],
      'WindGust' => $this->Data['WindGust'], 'Pressure' => $this->Data['Pressure'],
      'SysTemp' => $this->Data['SysTemp'], 'Temperature' => $this->Data['Temperature'],
      'BarAltitude' => $this->Data['BarAltitude'], 'WindChill' => $this->Data['WindChill'],
      'RelHumidity' => $this->Data['RelHumidity'], 'AbsHumidity' => $this->Data['AbsHumidity'],
      'DewPoint' => $this->Data['DewPoint']));
  }
  
  function CreateImage($FileName)
  {
    $Width = 150;
    $Height = 150;
    $Image = new Image();
    $Image->SetSize($Width, $Height);
    $Image->Brush->Color = COLOR_WHITE;
    $Image->FillRect(0, 0, $Width, $Height);
    $Image->Pen->Color = COLOR_BLUE;
    $Image->Line(0, 0, 0, $Height - 1);
    $Image->Line($Width - 1, 0, $Width - 1, $Height - 1);
    $Image->Line(0, $Height - 1, $Width - 1, $Height - 1);
    $Image->Line(0, 0, $Width - 1, 0);
    $Image->Line(0, 16, $Width - 1, 16);
    $Image->Font->Color = COLOR_BLACK;
    $Text = 'Meteo '.$this->Name;
    $Image->TextOut(($Width - $Image->TextWidth($Text)) / 2, 13, $Text);
    $Image->Font->Size = 30;
    $Text = $this->Data['Temperature'].'°C';
    $Image->TextOut(($Width - $Image->TextWidth($Text)) / 2, 56, $Text);
    $Image->Font->Size = 10;
    $Text = 'Pocitová: '.$this->Data['Temperature'].' °C';
    $Image->TextOut(($Width - $Image->TextWidth($Text)) / 2, $Height - 70, $Text);
    $Text = 'Rel. vlhkost: '.$this->Data['RelHumidity'].' %';
    $Image->TextOut(($Width - $Image->TextWidth($Text)) / 2, $Height - 54, $Text);
    $Text = 'Tlak: '.$this->Data['Pressure'].' hPa';
    $Image->TextOut(($Width - $Image->TextWidth($Text)) / 2, $Height - 38, $Text);
    $Text = 'Vítr: '.$this->Data['WindSpeed'].' m/s';
    $Image->TextOut(($Width - $Image->TextWidth($Text)) / 2, $Height - 22, $Text);
    $Text = date("d.n.Y H:i:s", $this->Data['Time']);
    $Image->TextOut(($Width - $Image->TextWidth($Text)) / 2, $Height - 6, $Text);
    $Image->SaveToFile($FileName);
  }
  
  function LoadFromDb()
  {
    $DbResult = $this->Database->select('Meteostation', '*', 'Id = '.$this->Id);
    $DbRow = $DbResult->fetch_assoc();
    $this->Name = $DbRow['Name'];
    $this->URL = $DbRow['URL'];
    $this->Period = $DbRow['Period'];
  }
}

$Meteo = new MeteoStation();
$Meteo->URL = 'http://meteo-koliba.zdechov.net/status.xml';
$Meteo->Name = 'Koliba Zděchov';
//$Meteo->LoadTestData();
$URL = 'http://stat.zdechov.net/meteo/add.php';
$I = 0;
while(1)
{
  $Meteo->DownloadData();
  $Meteo->CreateImage('koliba.png');
  if(($I % 6) == 0) 
  {
    file_get_contents($URL.'?MeasureId=28&Value='.$Meteo->Data['Temperature']);
    file_get_contents($URL.'?MeasureId=29&Value='.$Meteo->Data['AbsHumidity']);
    file_get_contents($URL.'?MeasureId=30&Value='.$Meteo->Data['BarAltitude']);
    file_get_contents($URL.'?MeasureId=31&Value='.$Meteo->Data['DewPoint']);
    file_get_contents($URL.'?MeasureId=32&Value='.$Meteo->Data['Pressure']);
    file_get_contents($URL.'?MeasureId=33&Value='.$Meteo->Data['RelHumidity']);
    file_get_contents($URL.'?MeasureId=34&Value='.$Meteo->Data['SysTemp']);
    file_get_contents($URL.'?MeasureId=35&Value='.$Meteo->Data['WindChill']);
    file_get_contents($URL.'?MeasureId=36&Value='.$Meteo->Data['WindDir']);
    file_get_contents($URL.'?MeasureId=37&Value='.$Meteo->Data['WindGust']);
    file_get_contents($URL.'?MeasureId=38&Value='.$Meteo->Data['WindSpeed']);
  }
  sleep(10);
  $I++;
}
